## insighttoolkit4 4.1.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8 FATAL_ERROR)

if(WIN32 OR NOT EXISTS /dev/urandom)
  cmake_minimum_required(VERSION 2.8.5)
endif()

project(ITK)

if( WIN32 )

  string( LENGTH "${CMAKE_CURRENT_SOURCE_DIR}" n )
  if( n GREATER 50 )
    message(
      FATAL_ERROR
      "ITK source code directory path length is too long (${n} > 50)."
      "Please move the ITK source code directory to a directory with a shorter path."
      )
  endif()

  string( LENGTH "${CMAKE_CURRENT_BINARY_DIR}" n )
  if( n GREATER 50 )
    message(
      FATAL_ERROR
      "ITK build directory path length is too long (${n} > 50)."
      "Please set the ITK build directory to a directory with a shorter path."
      )
  endif()

endif()

set(CMAKE_MODULE_PATH ${ITK_SOURCE_DIR}/CMake ${CMAKE_MODULE_PATH})
include(PreventInSourceBuilds)
include(PreventInBuildInstalls)
include(ITKModuleMacros)
include(ITKExternalData)
include(itkCheckSourceTree)

set(main_project_name ${_ITKModuleMacros_DEFAULT_LABEL})

#-----------------------------------------------------------------------------
# ITK version number.
set(ITK_VERSION_MAJOR "4")
set(ITK_VERSION_MINOR "1")
set(ITK_VERSION_PATCH "0")

if(NOT ITK_INSTALL_RUNTIME_DIR)
  set(ITK_INSTALL_RUNTIME_DIR bin)
endif()
if(NOT ITK_INSTALL_LIBRARY_DIR)
  set(ITK_INSTALL_LIBRARY_DIR lib)
endif()
if(NOT ITK_INSTALL_ARCHIVE_DIR)
  set(ITK_INSTALL_ARCHIVE_DIR lib)
endif()
if(NOT ITK_INSTALL_INCLUDE_DIR)
  set(ITK_INSTALL_INCLUDE_DIR include/ITK-${ITK_VERSION_MAJOR}.${ITK_VERSION_MINOR})
endif()
if(NOT ITK_INSTALL_DATA_DIR)
  set(ITK_INSTALL_DATA_DIR share/ITK-${ITK_VERSION_MAJOR}.${ITK_VERSION_MINOR})
endif()
if(NOT ITK_INSTALL_DOC_DIR)
  set(ITK_INSTALL_DOC_DIR share/doc/ITK-${ITK_VERSION_MAJOR}.${ITK_VERSION_MINOR})
endif()
if(NOT ITK_INSTALL_PACKAGE_DIR)
  set(ITK_INSTALL_PACKAGE_DIR "lib/cmake/ITK-${ITK_VERSION_MAJOR}.${ITK_VERSION_MINOR}")
endif()

# Override CMake's built-in add_* commands: assign LABELS to tests and targets
# automatically. Depends on the CMake variable itk-module being set to the
# "current" module when add_* is called.
macro(verify_itk_module_is_set)
  if("" STREQUAL "${itk-module}")
    message(FATAL_ERROR "CMake variable itk-module is not set")
  endif()
endmacro()

#-----------------------------------------------------------------------------
# Set a default build type if none was specified
if(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
  message(STATUS "Setting build type to 'Release' as none was specified.")
  set(CMAKE_BUILD_TYPE Release CACHE STRING "Choose the type of build." FORCE)
  # Set the possible values of build type for cmake-gui
  set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS "Debug" "Release" "MinSizeRel" "RelWithDebInfo")
endif()


#-----------------------------------------------------------------------------
# Enable runinng cppcheck for each module on its source and test directories.
option(ITK_CPPCHECK_TEST "Run cppcheck for static code analysis" OFF)
mark_as_advanced(ITK_CPPCHECK_TEST)

#-----------------------------------------------------------------------------
# Default values for CMake options may vary based on whether it's a
# dashboard build or not:
#
if("$ENV{DASHBOARD_TEST_FROM_CTEST}" STREQUAL "")
  # developer build
  set(ITK_BUILD_ALL_MODULES_DEFAULT ON)
  set(BUILD_EXAMPLES_DEFAULT ON)
else()
  # dashboard build
  set(ITK_BUILD_ALL_MODULES_DEFAULT ON)
  set(BUILD_EXAMPLES_DEFAULT ON)
endif()

#-----------------------------------------------------------------------------
# Enable the download and use of BrainWeb datasets.
# When this data is available, additional 3D tests are enabled.
option(ITK_USE_BRAINWEB_DATA "Download and use BrainWeb data for advanced testing" OFF)
mark_as_advanced(ITK_USE_BRAINWEB_DATA)

#-----------------------------------------------------------------------------
# ITK wrapper for add_test that automatically sets the test's LABELS property
# to the value of its containing module.
#
function(itk_add_test)
  # Add tests with data in the ITKData group.
  ExternalData_add_test(ITKData ${ARGN})

  if("NAME" STREQUAL "${ARGV0}")
    set(_iat_testname ${ARGV1})
  else()
    set(_iat_testname ${ARGV0})
  endif()

  if(itk-module)
    set(_label ${itk-module})
    if(TARGET ${itk-module}-all AND "${ARGN}" MATCHES "DATA{")
      add_dependencies(${itk-module}-all ITKData)
    endif()
  else()
    set(_label ${main_project_name})
  endif()

  set_property(TEST ${_iat_testname} PROPERTY LABELS ${_label})
endfunction()

#-----------------------------------------------------------------------------
# ITK build configuration options.
option(BUILD_SHARED_LIBS "Build ITK with shared libraries." OFF)
set(ITK_BUILD_SHARED_LIBS ${BUILD_SHARED_LIBS})

include(ITKSetStandardCompilerFlags)
#---------------------------------------------------------------
# run try compiles and tests for ITK
include(itkTestFriendTemplatedFunction)

set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${ITK_REQUIRED_C_FLAGS}")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${ITK_REQUIRED_CXX_FLAGS}")
set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} ${ITK_REQUIRED_LINK_FLAGS}")
set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} ${ITK_REQUIRED_LINK_FLAGS}")
set(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} ${ITK_REQUIRED_LINK_FLAGS}")

include(CTest)

include( CppcheckTargets )

# Setup build locations.
if(NOT CMAKE_RUNTIME_OUTPUT_DIRECTORY)
  set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${ITK_BINARY_DIR}/bin)
endif()
if(NOT CMAKE_LIBRARY_OUTPUT_DIRECTORY)
  set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${ITK_BINARY_DIR}/lib)
endif()
if(NOT CMAKE_ARCHIVE_OUTPUT_DIRECTORY)
  set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${ITK_BINARY_DIR}/lib)
endif()
set(ITK_MODULES_DIR "${ITK_BINARY_DIR}/${ITK_INSTALL_PACKAGE_DIR}/Modules")


#-----------------------------------------------------------------------------
# Provide compatibility options.
option(ITKV3_COMPATIBILITY "Enable compatibility with ITK3.x when possible." OFF)
option(ITK_LEGACY_REMOVE "Remove all legacy code completely." OFF)
option(ITK_LEGACY_SILENT "Silence all legacy code messages." OFF)
mark_as_advanced(ITK_LEGACY_REMOVE ITK_LEGACY_SILENT ITK_V3_COMPATIBILITY)

#-----------------------------------------------------------------------------
# ITK build classes that are in the review process
option(ITK_USE_REVIEW "Build algorithms that are candidates to be included in the Toolkit. This classes are not covered by the Backward Compatibility Policy, no
r the Copyright Policy of ITK." OFF)
mark_as_advanced(ITK_USE_REVIEW)

if (ITK_USE_REVIEW)
  set(Module_ITKReview ON)
endif(ITK_USE_REVIEW)

#-----------------------------------------------------------------------------
# ITK uses KWStyle for checking the coding style
INCLUDE(${ITK_SOURCE_DIR}/Utilities/KWStyle/KWStyle.cmake)

#-----------------------------------------------------------------------------
# ITK build the Examples that are illustrated in the Software Guide
option(BUILD_EXAMPLES "Build the Examples directory."
  ${BUILD_EXAMPLES_DEFAULT})

#-----------------------------------------------------------------------------
# Enable GPU support. Requires OpenCL to be installed
option(ITK_USE_GPU "GPU acceleration via OpenCL" OFF)
mark_as_advanced(ITK_USE_GPU)

# Manage FFT v3 Options
#
# USE_FFTWD -- use double precision fftw
option(USE_FFTWD "Use double precision fftw if found" OFF)
mark_as_advanced(USE_FFTWD)
#
# USE_FFTWF -- use single precision fftw
option(USE_FFTWF "Use single precision fftw if found" OFF)
mark_as_advanced(USE_FFTWF)

# USE_SYSTEM_FFTW -- locate a readybuilt fftw installation
option(USE_SYSTEM_FFTW "Use an installed version of fftw" OFF)
mark_as_advanced(USE_SYSTEM_FFTW)

if( USE_FFTWD OR USE_FFTWF )
  #
  # use ExternalProject
  include(ExternalProject)

  include(itkExternal_FFTW)
endif( USE_FFTWD OR USE_FFTWF )

if(NOT ITKV3_COMPATIBILITY)
  option(ITK_USE_64BITS_IDS "When ON, ITK will use 64 bits integers to index pixels. This is needed for managing images larger than 4Gb in some platforms." OFF)
  mark_as_advanced(ITK_USE_64BITS_IDS)
endif()

# ITK turn on concept checking
option(ITK_USE_CONCEPT_CHECKING "Turn on concept checking to give helpful errors at compile time if a type cannot be used as a template parameter." ON)
mark_as_advanced(ITK_USE_CONCEPT_CHECKING)
option(ITK_USE_STRICT_CONCEPT_CHECKING "Turn on Strict concept checking to give more stringent errors at compile time if a type cannot be used as a template parameter." OFF)
mark_as_advanced(ITK_USE_STRICT_CONCEPT_CHECKING)

#----------------------------------------------------------------------------
set(ITK_TEST_OUTPUT_DIR "${ITK_BINARY_DIR}/Testing/Temporary")

# Configure the default ITK_DATA_ROOT for the location of ITK Data.
set(ITK_DATA_ROOT ${ITK_SOURCE_DIR}/Testing/Data)

# Location of ITK Example Data.
set(ITK_EXAMPLE_DATA_ROOT "${ITK_SOURCE_DIR}/Examples/Data")

#This flag is used in particular, to enable some tests that require large memory to run.
# This probably can be discovered at configuration time by CMake. (Check with CMake developers).
set(ITK_COMPUTER_MEMORY_SIZE 1 CACHE STRING "Provide here the size of your RAM Memory in GigaBytes")
mark_as_advanced(ITK_COMPUTER_MEMORY_SIZE)




#----------------------------------------------------------------------
# Load the module DAG.
set(ITK_MODULES_ALL)
file(GLOB meta RELATIVE "${ITK_SOURCE_DIR}"
   "${ITK_SOURCE_DIR}/*/*/*/itk-module.cmake" # grouped modules
  )
foreach(f ${meta})
  include(${ITK_SOURCE_DIR}/${f})
  list(APPEND ITK_MODULES_ALL ${itk-module})
  get_filename_component(${itk-module}_BASE ${f} PATH)
  set(${itk-module}_SOURCE_DIR ${ITK_SOURCE_DIR}/${${itk-module}_BASE})
  set(${itk-module}_BINARY_DIR ${ITK_BINARY_DIR}/${${itk-module}_BASE})
  if(BUILD_TESTING AND EXISTS ${${itk-module}_SOURCE_DIR}/test)
    list(APPEND ITK_MODULES_ALL ${itk-module-test})
    set(${itk-module-test}_SOURCE_DIR ${${itk-module}_SOURCE_DIR}/test)
    set(${itk-module-test}_BINARY_DIR ${${itk-module}_BINARY_DIR}/test)
    set(${itk-module-test}_IS_TEST 1)
    set(${itk-module}_TESTED_BY ${itk-module-test})
    set(${itk-module-test}_TESTS_FOR ${itk-module})
  endif()

  # Reject bad dependencies.
  string(REGEX MATCHALL ";(ITKDeprecated|ITKReview|ITKIntegratedTest);"
    _bad_deps ";${ITK_MODULE_${itk-module}_DEPENDS};${ITK_MODULE_${itk-module-test}_DEPENDS};")
  foreach(dep ${_bad_deps})
    if(NOT "${itk-module}" MATCHES "^(${dep}|ITKIntegratedTest)$")
      message(FATAL_ERROR
        "Module \"${itk-module}\" loaded from\n"
        "  ${${itk-module}_BASE}/itk-module.cmake\n"
        "may not depend on module \"${dep}\".")
    endif()
  endforeach()
endforeach()
# Clear variables set later in each module.
unset(itk-module)
unset(itk-module-test)

# Validate the module DAG.
macro(itk_module_check itk-module _needed_by stack)
  if(NOT ITK_MODULE_${itk-module}_DECLARED)
    message(FATAL_ERROR "No such module \"${itk-module}\" needed by \"${_needed_by}\"")
  endif()
  if(check_started_${itk-module} AND NOT check_finished_${itk-module})
    # We reached a module while traversing its own dependencies recursively.
    set(msg "")
    foreach(entry ${stack})
      set(msg " ${entry} =>${msg}")
      if("${entry}" STREQUAL "${itk-module}")
        break()
      endif()
    endforeach()
    message(FATAL_ERROR "Module dependency cycle detected:\n ${msg} ${itk-module}")
  elseif(NOT check_started_${itk-module})
    # Traverse dependencies of this module.  Mark the start and finish.
    set(check_started_${itk-module} 1)
    foreach(dep IN LISTS ITK_MODULE_${itk-module}_DEPENDS)
      itk_module_check(${dep} ${itk-module} "${itk-module};${stack}")
    endforeach()
    set(check_finished_${itk-module} 1)
  endif()
endmacro()

foreach(itk-module ${ITK_MODULES_ALL})
  itk_module_check("${itk-module}" "" "")
endforeach()

#----------------------------------------------------------------------

# Provide an option for all modules.
option(ITK_BUILD_ALL_MODULES "Request to build all modules"

=== Wrapping/CMakeLists.txt ===
#==========================================================================
#
#   Copyright Insight Software Consortium
#
#   Licensed under the Apache License, Version 2.0 (the "License");
#   you may not use this file except in compliance with the License.
#   You may obtain a copy of the License at
#
#          http://www.apache.org/licenses/LICENSE-2.0.txt
#
#   Unless required by applicable law or agreed to in writing, software
#   distributed under the License is distributed on an "AS IS" BASIS,
#   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#   See the License for the specific language governing permissions and
#   limitations under the License.
#
#==========================================================================*/

project(WrapITK)

# set an internal cache to mark when this file is parsed
set(ITK_WRAPPING_REACHED ON CACHE INTERNAL "Wrapping folder has been reached")

# check cmake version
# Require 2.4.2 for MATH and LIST commands (REMOVE_ITEM is not the same in
# 2.4.1)
# 2.4.5 is required to parse the if(POLICY) command.
cmake_minimum_required(VERSION 2.8 FATAL_ERROR)
if(COMMAND CMAKE_POLICY)
  cmake_policy(SET CMP0003 NEW)
  if(POLICY CMP0011)
    cmake_policy(SET CMP0011 NEW)
  endif(POLICY CMP0011)

endif(COMMAND CMAKE_POLICY)
include("CMakeUtilityFunctions.cmake")

set(ITK_VERSION "${ITK_VERSION_MAJOR}.${ITK_VERSION_MINOR}.${ITK_VERSION_PATCH}")
if(NOT "${CMAKE_VERSION}" STRLESS "2.6.3")
  cmake_policy(SET CMP0011 OLD)
endif(NOT "${CMAKE_VERSION}" STRLESS "2.6.3")

enable_testing()
# include(CTest)
# if(BUILD_TESTING)
#   set(BUILDNAME "${BUILDNAME}" CACHE STRING "Name of build on the dashboard")
#   mark_as_advanced(BUILDNAME)
# endif(BUILD_TESTING)

###############################################################################
# Config ITKWrap
###############################################################################

# Set up options needed for ConfigureWrapping

# set WrapITK version
set(WrapITK_VERSION_MAJOR 0)
set(WrapITK_VERSION_MINOR 4)
set(WrapITK_VERSION_PATCH 0)


option(ITK_WRAP_unsigned_char "Wrap unsigned char type" ON)
option(ITK_WRAP_unsigned_short "Wrap unsigned short type" OFF)
option(ITK_WRAP_unsigned_long "Wrap unsigned long type" OFF)

option(ITK_WRAP_signed_char "Wrap signed char type" OFF)
option(ITK_WRAP_signed_short "Wrap signed short type" ON)
option(ITK_WRAP_signed_long "Wrap signed long type" OFF)

option(ITK_WRAP_float "Wrap float type" ON)
option(ITK_WRAP_double "Wrap double type" OFF)

option(ITK_WRAP_vector_float "Wrap vector float type" ON)
option(ITK_WRAP_vector_double "Wrap vector double type" OFF)

option(ITK_WRAP_covariant_vector_float "Wrap covariant vector float type" ON)
option(ITK_WRAP_covariant_vector_double "Wrap covariant vector double type" OFF)

option(ITK_WRAP_rgb_unsigned_char "Wrap RGB< unsigned char > type" ON)
option(ITK_WRAP_rgb_unsigned_short "Wrap RGB< unsigned short > type" OFF)

option(ITK_WRAP_rgba_unsigned_char "Wrap RGBA< unsigned char > type" ON)
option(ITK_WRAP_rgba_unsigned_short "Wrap RGBA< unsigned short > type" OFF)

option(ITK_WRAP_complex_float "Wrap complex<float> type" ON)
option(ITK_WRAP_complex_double "Wrap complex<double> type" OFF)

set(ITK_WRAP_DIMS "2;3" CACHE STRING "dimensions available separated by semicolons (;)")

option(INSTALL_WRAP_ITK_COMPATIBILITY "Install FindWrapITK.cmake and WrapITK.pth (so cmake and python can find WrapITK) as part of the standard installation process. This requires admin privileges. These files can be separately installed by making the install_wrapitk_compatibility target. " ON)

if(ITK_INSTALL_PACKAGE_DIR)
  string(REGEX REPLACE "^/" "" path "${ITK_INSTALL_PACKAGE_DIR}/WrapITK/")
else()
  set(path "lib/InsightToolkit/WrapITK/")
endif()
set(WRAP_ITK_INSTALL_PREFIX "${path}" CACHE INTERNAL "subpath where where most of WrapITK files will be installed")

# Output directories.
set(WRAP_ITK_CONFIG_DIR "${WrapITK_SOURCE_DIR}/")
set(WRAP_ITK_CMAKE_DIR "${WrapITK_SOURCE_DIR}")
set(ITK_WRAP_JAVA_DIR "${WrapITK_BINARY_DIR}/Java")

if(NOT CMAKE_LIBRARY_OUTPUT_DIRECTORY)
  set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${WrapITK_BINARY_DIR}/lib CACHE INTERNAL "Single output directory for building all libraries.")
endif(NOT CMAKE_LIBRARY_OUTPUT_DIRECTORY)

if(NOT EXECUTABLE_OUTPUT_PATH)
  set(EXECUTABLE_OUTPUT_PATH ${WrapITK_BINARY_DIR}/bin CACHE INTERNAL "Single output directory for building all executables.")
endif(NOT EXECUTABLE_OUTPUT_PATH)

mark_as_advanced(CMAKE_LIBRARY_OUTPUT_DIRECTORY EXECUTABLE_OUTPUT_PATH WRAP_ITK_INSTALL_PREFIX)

set(CXX_TEST_PATH ${EXECUTABLE_OUTPUT_PATH})

###############################################################################
# Configure CPack
###############################################################################

# CPack was introduced in cmake 2.4
set(CMAKE_VERSION "${CMAKE_CACHE_MAJOR_VERSION}.${CMAKE_CACHE_MINOR_VERSION}.${CMAKE_CACHE_RELEASE_VERSION}")
if("${CMAKE_VERSION}" STRGREATER "2.4")
  set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "Enhanced generators support for the Insight Toolkit")
  set(CPACK_PACKAGE_VENDOR "Gaetan Lehmann, Zachary Pincus")
  set(CPACK_PACKAGE_VERSION_MAJOR "${WrapITK_VERSION_MAJOR}")
  set(CPACK_PACKAGE_VERSION_MINOR "${WrapITK_VERSION_MINOR}")
  set(CPACK_PACKAGE_VERSION_PATCH "${WrapITK_VERSION_PATCH}")
  # set(CPACK_PACKAGE_INSTALL_DIRECTORY "WrapITK-${WrapITK_VERSION_MAJOR}.${WrapITK_VERSION_MINOR}")
  # set(CPACK_PACKAGE_DESCRIPTION_FILE "${CMAKE_CURRENT_SOURCE_DIR}/README")
  # set(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_CURRENT_SOURCE_DIR}/Documentation/Copyright/ITKCopyright.txt")
  include(CPack)
endif("${CMAKE_VERSION}" STRGREATER "2.4")

install(FILES
  CMakeUtilityFunctions.cmake
  ConfigureWrapping.cmake
  TypedefMacros.cmake
  WrapBasicTypes.cmake
  WrapITKTypes.cmake
  DESTINATION "${WRAP_ITK_INSTALL_PREFIX}/Configuration"
)

install(FILES "${WrapITK_BINARY_DIR}/InstallOnly/WrapITKConfig.cmake"
  DESTINATION "${WRAP_ITK_INSTALL_PREFIX}/"
)

# Add a custom target to drive installation of the WrapITK-compatibility files
if(INSTALL_WRAP_ITK_COMPATIBILITY)
  # if we should by default install the files, make a custom target that will
  # always be built.
  CREATE_INSTALL_AT_ABSOLUTE_PATH_TARGET(install_wrapitk_compatibility DEFAULT
    "Installing WrapITK compatibility files. Requires admin priviliges: turn off INSTALL_WRAP_ITK_COMPATIBILITY in cmake to disable.")
else(INSTALL_WRAP_ITK_COMPATIBILITY)
  # otherwise, add a target that will install the files only when that target is
  # manually built.
  CREATE_INSTALL_AT_ABSOLUTE_PATH_TARGET(install_wrapitk_compatibility ON_DEMAND
    "Installing WrapITK compatibility files. Requires admin priviliges.")
endif(INSTALL_WRAP_ITK_COMPATIBILITY)

INSTALL_AT_ABSOLUTE_PATH(install_wrapitk_compatibility "${CMAKE_ROOT}/Modules" "${WrapITK_BINARY_DIR}/InstallOnly/FindWrapITK.cmake")

set(WRAP_ITK_TYPEDEFS_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/Typedefs")
set(WRAP_ITK_LIB_DIRECTORY  "${CMAKE_LIBRARY_OUTPUT_DIRECTORY}")


find_package(ITK REQUIRED)
include(${ITK_USE_FILE})

###############################################################################
# Setup test driver
###############################################################################

set(ITK_TEST_DRIVER "itkTestDriver")

###############################################################################
# The real work on wrappers
###############################################################################

include(ConfigureWrapping.cmake)

###############################################################################
# let the different generators running some code before begining to parse the
# modules
###############################################################################

itk_wrap_modules()

###############################################################################
# Configure specific wrapper modules
###############################################################################

add_subdirectory("${CMAKE_CURRENT_SOURCE_DIR}/Modules" "${CMAKE_CURRENT_BINARY_DIR}/Modules")


###############################################################################
# let the different generators running some code after have parsed all the
# modules
###############################################################################

itk_end_wrap_modules()

###############################################################################
# Configure WrapITKConfig.cmake and FindWrapITK.cmake for external projects
###############################################################################
# First, configure for use directly from the build dir.
# we must add the options for the generators for the build dir case, so the
# external project won't find all the generators, even the usued ones.
# In the installed case, this feature is useful to let the packagers make several
# subpackages for wrapitk.
set(CONFIG_WRAP_ITK_MORE_OPTIONS)
foreach(lang ${WRAP_ITK_GENERATORS} ${WRAP_ITK_UNUSED_GENERATORS})
  string(TOUPPER "${lang}" lang_upper)
  set(CONFIG_WRAP_ITK_MORE_OPTIONS "${CONFIG_WRAP_ITK_MORE_OPTIONS}set(WRAP_ITK_${lang_upper} ${WRAP_ITK_${lang_upper}} CACHE BOOL \"Build swig ${lang} wrapper support.\")\n")
endforeach(lang)
set(CONFIG_CONFIG_DIR "${WrapITK_SOURCE_DIR}/ConfigurationInputs")
set(CONFIG_CMAKE_DIR "${WrapITK_SOURCE_DIR}")
set(CONFIG_WRAP_ITK_TYPEDEFS_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/Typedefs")
set(CONFIG_WRAP_ITK_INSTALL_LOCATION "${CMAKE_INSTALL_PREFIX}/${WRAP_ITK_INSTALL_PREFIX}")
set(CONFIG_WRAP_ITK_MODULES "${WRAP_ITK_MODULES}")
set(CONFIG_ITK_WRAP_PYTHON_MODULE "${WrapITK_BINARY_DIR}/Python/\\\${CTEST_CONFIGURATION_TYPE}")
set(CONFIG_ITK_WRAP_PYTHON_LIBS "${CMAKE_LIBRARY_OUTPUT_DIRECTORY}/\\\${CTEST_CONFIGURATION_TYPE}")
set(CONFIG_WRAP_ITK_LIB_DIR  "${CMAKE_LIBRARY_OUTPUT_DIRECTORY}")
configure_file("${WRAP_ITK_CONFIG_DIR}/WrapITKConfig.cmake.in"
               "${WrapITK_BINARY_DIR}/WrapITKConfig.cmake"
               @ONLY IMMEDIATE)

set(CONFIG_WRAP_ITK_DIR "${WrapITK_BINARY_DIR}")
configure_file("${WRAP_ITK_CONFIG_DIR}/FindWrapITK.cmake.in"
               "${WrapITK_BINARY_DIR}/FindWrapITK.cmake"
               @ONLY IMMEDIATE)

# Second, configure for installed use. Ensure that no absolute paths
# go into the installed config file, so that it is as portable as possible.
set(CONFIG_WRAP_ITK_MORE_OPTIONS)
set(CONFIG_CONFIG_DIR "\${WrapITK_DIR}/Configuration/Inputs")
set(CONFIG_CMAKE_DIR "\${WrapITK_DIR}/Configuration")
set(CONFIG_WRAP_ITK_TYPEDEFS_DIRECTORY "\${WrapITK_DIR}/Configuration/Typedefs")
set(CONFIG_WRAP_ITK_INSTALL_LOCATION "\${WrapITK_DIR}")
set(CONFIG_ITK_WRAP_PYTHON_MODULE "\${WrapITK_DIR}/Python/")
set(CONFIG_ITK_WRAP_PYTHON_LIBS "\${WrapITK_DIR}/lib")
set(CONFIG_WRAP_ITK_LIB_DIR  "\${WrapITK_DIR}/lib")
configure_file("${WRAP_ITK_CONFIG_DIR}/WrapITKConfig.cmake.in"
               "${WrapITK_BINARY_DIR}/InstallOnly/WrapITKConfig.cmake"
               @ONLY IMMEDIATE)

set(CONFIG_WRAP_ITK_DIR "${CMAKE_INSTALL_PREFIX}/${WRAP_ITK_INSTALL_PREFIX}")
configure_file("${WRAP_ITK_CONFIG_DIR}/FindWrapITK.cmake.in"
               "${WrapITK_BINARY_DIR}/InstallOnly/FindWrapITK.cmake"
               @ONLY IMMEDIATE)

=== Examples/Filtering/CMakeLists.txt ===
project(FilteringExamples)
include_regular_expression("^.*$")
add_executable(CompositeFilterExample CompositeFilterExample.cxx )
target_link_libraries(CompositeFilterExample  ${ITK_LIBRARIES})
add_executable(FlipImageFilter FlipImageFilter.cxx )
target_link_libraries(FlipImageFilter  ${ITK_LIBRARIES})
add_executable(FFTImageFilter FFTImageFilter.cxx )
target_link_libraries(FFTImageFilter  ${ITK_LIBRARIES})
if( USE_FFTWF )
  add_executable(FFTDirectInverse2 FFTDirectInverse2.cxx )
  target_link_libraries(FFTDirectInverse2  ${ITK_LIBRARIES})
endif( USE_FFTWF )
add_executable(GradientMagnitudeImageFilter GradientMagnitudeImageFilter.cxx )
target_link_libraries(GradientMagnitudeImageFilter  ${ITK_LIBRARIES})
add_executable(GradientMagnitudeRecursiveGaussianImageFilter GradientMagnitudeRecursiveGaussianImageFilter.cxx )
target_link_libraries(GradientMagnitudeRecursiveGaussianImageFilter  ${ITK_LIBRARIES})
add_executable(GradientRecursiveGaussianImageFilter GradientRecursiveGaussianImageFilter.cxx )
target_link_libraries(GradientRecursiveGaussianImageFilter  ${ITK_LIBRARIES})
add_executable(GrayscaleFunctionDilateImageFilter GrayscaleFunctionDilateImageFilter.cxx )
target_link_libraries(GrayscaleFunctionDilateImageFilter  ${ITK_LIBRARIES})
add_executable(BinaryThresholdImageFilter BinaryThresholdImageFilter.cxx )
target_link_libraries(BinaryThresholdImageFilter  ${ITK_LIBRARIES})
add_executable(BinaryMedianImageFilter BinaryMedianImageFilter.cxx )
target_link_libraries(BinaryMedianImageFilter  ${ITK_LIBRARIES})
add_executable(OtsuThresholdImageFilter OtsuThresholdImageFilter.cxx )
target_link_libraries(OtsuThresholdImageFilter  ${ITK_LIBRARIES})
add_executable(OtsuMultipleThresholdImageFilter OtsuMultipleThresholdImageFilter.cxx )
target_link_libraries(OtsuMultipleThresholdImageFilter ${ITK_LIBRARIES})
add_executable(ThresholdImageFilter ThresholdImageFilter.cxx )
target_link_libraries(ThresholdImageFilter  ${ITK_LIBRARIES})
add_executable(CastingImageFilters CastingImageFilters.cxx )
target_link_libraries(CastingImageFilters  ${ITK_LIBRARIES})
add_executable(CannyEdgeDetectionImageFilter CannyEdgeDetectionImageFilter.cxx )
target_link_libraries(CannyEdgeDetectionImageFilter  ${ITK_LIBRARIES})
add_executable(MedianImageFilter MedianImageFilter.cxx )
target_link_libraries(MedianImageFilter  ${ITK_LIBRARIES})
add_executable(MeanImageFilter MeanImageFilter.cxx )
target_link_libraries(MeanImageFilter  ${ITK_LIBRARIES})
add_executable(MathematicalMorphologyBinaryFilters MathematicalMorphologyBinaryFilters.cxx )
target_link_libraries(MathematicalMorphologyBinaryFilters  ${ITK_LIBRARIES})
add_executable(MathematicalMorphologyGrayscaleFilters MathematicalMorphologyGrayscaleFilters.cxx )
target_link_libraries(MathematicalMorphologyGrayscaleFilters  ${ITK_LIBRARIES})
add_executable(BinaryMinMaxCurvatureFlowImageFilter BinaryMinMaxCurvatureFlowImageFilter.cxx )
target_link_libraries(BinaryMinMaxCurvatureFlowImageFilter  ${ITK_LIBRARIES})
add_executable(DiscreteGaussianImageFilter DiscreteGaussianImageFilter.cxx )
target_link_libraries(DiscreteGaussianImageFilter  ${ITK_LIBRARIES})
add_executable(GaussianBlurImageFunction GaussianBlurImageFunction.cxx )
target_link_libraries(GaussianBlurImageFunction  ${ITK_LIBRARIES})
add_executable(LaplacianRecursiveGaussianImageFilter1 LaplacianRecursiveGaussianImageFilter1.cxx )
target_link_libraries(LaplacianRecursiveGaussianImageFilter1  ${ITK_LIBRARIES})
add_executable(ScaleSpaceGenerator2D ScaleSpaceGenerator2D.cxx )
target_link_libraries(ScaleSpaceGenerator2D  ${ITK_LIBRARIES})
add_executable(BinomialBlurImageFilter BinomialBlurImageFilter.cxx )
target_link_libraries(BinomialBlurImageFilter  ${ITK_LIBRARIES})
add_executable(CurvatureAnisotropicDiffusionImageFilter CurvatureAnisotropicDiffusionImageFilter.cxx )
target_link_libraries(CurvatureAnisotropicDiffusionImageFilter  ${ITK_LIBRARIES})
add_executable(VectorGradientAnisotropicDiffusionImageFilter VectorGradientAnisotropicDiffusionImageFilter.cxx )
target_link_libraries(VectorGradientAnisotropicDiffusionImageFilter  ${ITK_LIBRARIES})
add_executable(VectorCurvatureAnisotropicDiffusionImageFilter VectorCurvatureAnisotropicDiffusionImageFilter.cxx )
target_link_libraries(VectorCurvatureAnisotropicDiffusionImageFilter  ${ITK_LIBRARIES})
add_executable(RGBToGrayscale RGBToGrayscale.cxx )
target_link_libraries(RGBToGrayscale  ${ITK_LIBRARIES})
add_executable(BilateralImageFilter BilateralImageFilter.cxx )
target_link_libraries(BilateralImageFilter  ${ITK_LIBRARIES})
add_executable(ResampleOrientedImageFilter ResampleOrientedImageFilter.cxx )
target_link_libraries(ResampleOrientedImageFilter  ${ITK_LIBRARIES})
add_executable(ResampleImageFilter2 ResampleImageFilter2.cxx )
target_link_libraries(ResampleImageFilter2  ${ITK_LIBRARIES})
add_executable(GradientAnisotropicDiffusionImageFilter GradientAnisotropicDiffusionImageFilter.cxx )
target_link_libraries(GradientAnisotropicDiffusionImageFilter  ${ITK_LIBRARIES})
add_executable(CurvatureFlowImageFilter CurvatureFlowImageFilter.cxx )
target_link_libraries(CurvatureFlowImageFilter  ${ITK_LIBRARIES})
add_executable(GradientVectorFlowImageFilter GradientVectorFlowImageFilter.cxx )
target_link_libraries(GradientVectorFlowImageFilter  ${ITK_LIBRARIES})
add_executable(SigmoidImageFilter SigmoidImageFilter.cxx )
target_link_libraries(SigmoidImageFilter  ${ITK_LIBRARIES})
add_executable(RGBCurvatureAnisotropicDiffusionImageFilter RGBCurvatureAnisotropicDiffusionImageFilter.cxx )
target_link_libraries(RGBCurvatureAnisotropicDiffusionImageFilter  ${ITK_LIBRARIES})
add_executable(RGBGradientAnisotropicDiffusionImageFilter RGBGradientAnisotropicDiffusionImageFilter.cxx )
target_link_libraries(RGBGradientAnisotropicDiffusionImageFilter  ${ITK_LIBRARIES})
add_executable(SignedDanielssonDistanceMapImageFilter SignedDanielssonDistanceMapImageFilter.cxx )
target_link_libraries(SignedDanielssonDistanceMapImageFilter  ${ITK_LIBRARIES})
add_executable(SecondDerivativeRecursiveGaussianImageFilter SecondDerivativeRecursiveGaussianImageFilter.cxx )
target_link_libraries(SecondDerivativeRecursiveGaussianImageFilter  ${ITK_LIBRARIES})
add_executable(DerivativeImageFilter DerivativeImageFilter.cxx )
target_link_libraries(DerivativeImageFilter  ${ITK_LIBRARIES})
add_executable(DanielssonDistanceMapImageFilter DanielssonDistanceMapImageFilter.cxx )
target_link_libraries(DanielssonDistanceMapImageFilter  ${ITK_LIBRARIES})
add_executable(AntiAliasBinaryImageFilter AntiAliasBinaryImageFilter.cxx )
target_link_libraries(AntiAliasBinaryImageFilter  ${ITK_LIBRARIES})
add_executable(ResampleImageFilter ResampleImageFilter.cxx )
target_link_libraries(ResampleImageFilter  ${ITK_LIBRARIES})
add_executable(SmoothingRecursiveGaussianImageFilter SmoothingRecursiveGaussianImageFilter.cxx )
target_link_libraries(SmoothingRecursiveGaussianImageFilter  ${ITK_LIBRARIES})
add_executable(SmoothingRecursiveGaussianImageFilter2 SmoothingRecursiveGaussianImageFilter2.cxx )
target_link_libraries(SmoothingRecursiveGaussianImageFilter2  ${ITK_LIBRARIES})
add_executable(LaplacianRecursiveGaussianImageFilter2 LaplacianRecursiveGaussianImageFilter2.cxx )
target_link_libraries(LaplacianRecursiveGaussianImageFilter2  ${ITK_LIBRARIES})
add_executable(MorphologicalImageEnhancement MorphologicalImageEnhancement.cxx )
target_link_libraries(MorphologicalImageEnhancement  ${ITK_LIBRARIES})
add_executable(MinMaxCurvatureFlowImageFilter MinMaxCurvatureFlowImageFilter.cxx )
target_link_libraries(MinMaxCurvatureFlowImageFilter  ${ITK_LIBRARIES})
add_executable(FFTImageFilterFourierDomainFiltering FFTImageFilterFourierDomainFiltering.cxx )
target_link_libraries(FFTImageFilterFourierDomainFiltering  ${ITK_LIBRARIES})
add_executable(LaplacianImageFilter LaplacianImageFilter.cxx )
target_link_libraries(LaplacianImageFilter  ${ITK_LIBRARIES})
add_executable(ResampleImageFilter3 ResampleImageFilter3.cxx )
target_link_libraries(ResampleImageFilter3  ${ITK_LIBRARIES})
add_executable(ResampleImageFilter4 ResampleImageFilter4.cxx )
target_link_libraries(ResampleImageFilter4  ${ITK_LIBRARIES})
add_executable(VotingBinaryHoleFillingImageFilter VotingBinaryHoleFillingImageFilter.cxx )
target_link_libraries(VotingBinaryHoleFillingImageFilter  ${ITK_LIBRARIES})
add_executable(VotingBinaryIterativeHoleFillingImageFilter VotingBinaryIterativeHoleFillingImageFilter.cxx )
target_link_libraries(VotingBinaryIterativeHoleFillingImageFilter  ${ITK_LIBRARIES})
add_executable(ResampleImageFilter5 ResampleImageFilter5.cxx )
target_link_libraries(ResampleImageFilter5  ${ITK_LIBRARIES})
add_executable(ResampleImageFilter6 ResampleImageFilter6.cxx )
target_link_libraries(ResampleImageFilter6  ${ITK_LIBRARIES})
add_executable(ResampleImageFilter8 ResampleImageFilter8.cxx )
target_link_libraries(ResampleImageFilter8  ${ITK_LIBRARIES})
add_executable(ResampleImageFilter9 ResampleImageFilter9.cxx )
target_link_libraries(ResampleImageFilter9  ${ITK_LIBRARIES})
add_executable(ResampleVolumesToBeIsotropic ResampleVolumesToBeIsotropic.cxx )
target_link_libraries(ResampleVolumesToBeIsotropic  ${ITK_LIBRARIES})
add_executable(SubsampleVolume SubsampleVolume.cxx )
target_link_libraries(SubsampleVolume  ${ITK_LIBRARIES})
add_executable(SpatialObjectToImage1 SpatialObjectToImage1.cxx )
target_link_libraries(SpatialObjectToImage1  ${ITK_LIBRARIES})
add_executable(SpatialObjectToImage2 SpatialObjectToImage2.cxx )
target_link_libraries(SpatialObjectToImage2  ${ITK_LIBRARIES})
add_executable(SpatialObjectToImage3 SpatialObjectToImage3.cxx )
target_link_libraries(SpatialObjectToImage3  ${ITK_LIBRARIES})
add_executable(LaplacianSharpeningImageFilter LaplacianSharpeningImageFilter.cxx )
target_link_libraries(LaplacianSharpeningImageFilter  ${ITK_LIBRARIES})
add_executable(VectorIndexSelection VectorIndexSelection.cxx )
target_link_libraries(VectorIndexSelection  ${ITK_LIBRARIES})
add_executable(VesselnessMeasureImageFilter VesselnessMeasureImageFilter.cxx )
target_link_libraries(VesselnessMeasureImageFilter  ${ITK_LIBRARIES})
add_executable(DiffusionTensor3DReconstructionImageFilter DiffusionTensor3DReconstructionImageFilter.cxx)
target_link_libraries(DiffusionTensor3DReconstructionImageFilter ${ITK_LIBRARIES})
add_executable(FFTDirectInverse FFTDirectInverse.cxx )
target_link_libraries(FFTDirectInverse  ${ITK_LIBRARIES})
add_executable(ZeroCrossingBasedEdgeDetectionImageFilter ZeroCrossingBasedEdgeDetectionImageFilter.cxx )
target_link_libraries(ZeroCrossingBasedEdgeDetectionImageFilter  ${ITK_LIBRARIES})
add_executable(WarpImageFilter1 WarpImageFilter1.cxx )
target_link_libraries(WarpImageFilter1  ${ITK_LIBRARIES})
add_executable(SurfaceExtraction SurfaceExtraction.cxx )
target_link_libraries(SurfaceExtraction  ${ITK_LIBRARIES})
add_executable(DigitallyReconstructedRadiograph1 DigitallyReconstructedRadiograph1.cxx )
target_link_libraries(DigitallyReconstructedRadiograph1  ${ITK_LIBRARIES})
add_executable(ResampleImageFilter7 ResampleImageFilter7.cxx )
target_link_libraries(ResampleImageFilter7  ${ITK_LIBRARIES})

if(BUILD_TESTING)
  add_subdirectory(test)
endif(BUILD_TESTING)

=== Examples/IO/CMakeLists.txt ===
project(IOExamples)

add_executable(ImageReadWrite ImageReadWrite.cxx )
target_link_libraries(ImageReadWrite  ${ITK_LIBRARIES})

add_executable(ImageReadCastWrite ImageReadCastWrite.cxx )
target_link_libraries(ImageReadCastWrite  ${ITK_LIBRARIES})

add_executable(ImageReadExtractFilterInsertWrite ImageReadExtractFilterInsertWrite.cxx )
target_link_libraries(ImageReadExtractFilterInsertWrite  ${ITK_LIBRARIES})

add_executable(ImageReadRegionOfInterestWrite ImageReadRegionOfInterestWrite.cxx )
target_link_libraries(ImageReadRegionOfInterestWrite  ${ITK_LIBRARIES})

add_executable(RGBImageReadWrite RGBImageReadWrite.cxx )
target_link_libraries(RGBImageReadWrite  ${ITK_LIBRARIES})

add_executable(CovariantVectorImageRead CovariantVectorImageRead.cxx )
target_link_libraries(CovariantVectorImageRead  ${ITK_LIBRARIES})

add_executable(CovariantVectorImageExtractComponent CovariantVectorImageExtractComponent.cxx )
target_link_libraries(CovariantVectorImageExtractComponent  ${ITK_LIBRARIES})

add_executable(VectorImageReadWrite VectorImageReadWrite.cxx )
target_link_libraries(VectorImageReadWrite  ${ITK_LIBRARIES})

add_executable(ComplexImageReadWrite ComplexImageReadWrite.cxx )
target_link_libraries(ComplexImageReadWrite  ${ITK_LIBRARIES})

add_executable(ImageReadExportVTK ImageReadExportVTK.cxx )
target_link_libraries(ImageReadExportVTK  ${ITK_LIBRARIES})

add_executable(RGBImageSeriesReadWrite RGBImageSeriesReadWrite.cxx )
target_link_libraries(RGBImageSeriesReadWrite  ${ITK_LIBRARIES})

add_executable(ImageSeriesReadWrite ImageSeriesReadWrite.cxx )
target_link_libraries(ImageSeriesReadWrite  ${ITK_LIBRARIES})

add_executable(ImageSeriesReadWrite2 ImageSeriesReadWrite2.cxx )
target_link_libraries(ImageSeriesReadWrite2  ${ITK_LIBRARIES})

add_executable(ImageReadImageSeriesWrite ImageReadImageSeriesWrite.cxx )
target_link_libraries(ImageReadImageSeriesWrite  ${ITK_LIBRARIES})

add_executable(DicomSeriesReadImageWrite2 DicomSeriesReadImageWrite2.cxx )
target_link_libraries(DicomSeriesReadImageWrite2  ${ITK_LIBRARIES})

add_executable(DicomSeriesReadGaussianImageWrite DicomSeriesReadGaussianImageWrite.cxx )
target_link_libraries(DicomSeriesReadGaussianImageWrite  ${ITK_LIBRARIES})

add_executable(DicomSeriesReadPrintTags DicomSeriesReadPrintTags.cxx )
target_link_libraries(DicomSeriesReadPrintTags  ${ITK_LIBRARIES})

add_executable(DicomImageReadPrintTags DicomImageReadPrintTags.cxx )
target_link_libraries(DicomImageReadPrintTags  ${ITK_LIBRARIES})

add_executable(DicomImageReadWrite DicomImageReadWrite.cxx )
target_link_libraries(DicomImageReadWrite  ${ITK_LIBRARIES})

add_executable(ImageReadDicomSeriesWrite ImageReadDicomSeriesWrite.cxx )
target_link_libraries(ImageReadDicomSeriesWrite  ${ITK_LIBRARIES})

add_executable(DicomImageReadChangeHeaderWrite DicomImageReadChangeHeaderWrite.cxx )
target_link_libraries(DicomImageReadChangeHeaderWrite  ${ITK_LIBRARIES})

add_executable(DicomSeriesReadSeriesWrite DicomSeriesReadSeriesWrite.cxx )
target_link_libraries(DicomSeriesReadSeriesWrite  ${ITK_LIBRARIES})

add_executable(DicomPrintPatientInformation DicomPrintPatientInformation.cxx )
target_link_libraries(DicomPrintPatientInformation  ${ITK_LIBRARIES})

add_executable(TransformReadWrite TransformReadWrite.cxx )
target_link_libraries(TransformReadWrite  ${ITK_LIBRARIES})

add_executable(VisibleHumanStreamReadWrite  VisibleHumanStreamReadWrite.cxx )
target_link_libraries(VisibleHumanStreamReadWrite  ${ITK_LIBRARIES})

add_executable(VisibleHumanPasteWrite  VisibleHumanPasteWrite.cxx )
target_link_libraries(VisibleHumanPasteWrite  ${ITK_LIBRARIES})

add_executable(CovariantVectorImageWrite CovariantVectorImageWrite.cxx )
target_link_libraries(CovariantVectorImageWrite  ${ITK_LIBRARIES})

add_executable(ImageReadExtractWrite ImageReadExtractWrite.cxx )
target_link_libraries(ImageReadExtractWrite  ${ITK_LIBRARIES})

add_executable(ConvertAnalyzeFile ConvertAnalyzeFile.cxx)
target_link_libraries(ConvertAnalyzeFile ${ITK_LIBRARIES})

if(BUILD_TESTING)
  add_subdirectory(test)
endif(BUILD_TESTING)

=== Examples/Iterators/CMakeLists.txt ===
#
#  Examples on the use of Iterators.
#
project(IteratorExamples)
include_regular_expression("^.*$")

add_executable(NeighborhoodIterators4 NeighborhoodIterators4.cxx)
target_link_libraries(NeighborhoodIterators4 ${ITK_LIBRARIES})

add_executable(NeighborhoodIterators5 NeighborhoodIterators5.cxx)
target_link_libraries(NeighborhoodIterators5 ${ITK_LIBRARIES})

add_executable(ImageRandomConstIteratorWithIndex ImageRandomConstIteratorWithIndex.cxx)
target_link_libraries(ImageRandomConstIteratorWithIndex ${ITK_LIBRARIES})

add_executable(NeighborhoodIterators1 NeighborhoodIterators1.cxx)
target_link_libraries(NeighborhoodIterators1 ${ITK_LIBRARIES})

add_executable(NeighborhoodIterators2 NeighborhoodIterators2.cxx)
target_link_libraries(NeighborhoodIterators2 ${ITK_LIBRARIES})

add_executable(NeighborhoodIterators3 NeighborhoodIterators3.cxx)
target_link_libraries(NeighborhoodIterators3 ${ITK_LIBRARIES})

add_executable(NeighborhoodIterators6 NeighborhoodIterators6.cxx)
target_link_libraries(NeighborhoodIterators6 ${ITK_LIBRARIES})

add_executable(ImageRegionIteratorWithIndex ImageRegionIteratorWithIndex.cxx)
target_link_libraries(ImageRegionIteratorWithIndex ${ITK_LIBRARIES})

add_executable(ImageRegionIterator ImageRegionIterator.cxx)
target_link_libraries(ImageRegionIterator ${ITK_LIBRARIES})

add_executable(ImageLinearIteratorWithIndex2 ImageLinearIteratorWithIndex2.cxx)
target_link_libraries(ImageLinearIteratorWithIndex2 ${ITK_LIBRARIES})

add_executable(ImageLinearIteratorWithIndex ImageLinearIteratorWithIndex.cxx)
target_link_libraries(ImageLinearIteratorWithIndex ${ITK_LIBRARIES})

add_executable(ImageSliceIteratorWithIndex ImageSliceIteratorWithIndex.cxx)
target_link_libraries(ImageSliceIteratorWithIndex ${ITK_LIBRARIES})

add_executable(ShapedNeighborhoodIterators1 ShapedNeighborhoodIterators1.cxx)
target_link_libraries(ShapedNeighborhoodIterators1 ${ITK_LIBRARIES})

add_executable(ShapedNeighborhoodIterators2 ShapedNeighborhoodIterators2.cxx)
target_link_libraries(ShapedNeighborhoodIterators2 ${ITK_LIBRARIES})

if(BUILD_TESTING)
  add_subdirectory(test)
endif(BUILD_TESTING)

=== Examples/Segmentation/CMakeLists.txt ===
#
# Examples on the use of segmentation algorithms
#

project(ImageSegmentation)
include_regular_expression("^.*$")

add_executable(ConfidenceConnected ConfidenceConnected.cxx )
target_link_libraries(ConfidenceConnected ${ITK_LIBRARIES})

add_executable(ConfidenceConnected3D ConfidenceConnected3D.cxx )
target_link_libraries(ConfidenceConnected3D ${ITK_LIBRARIES})

add_executable(NeighborhoodConnectedImageFilter NeighborhoodConnectedImageFilter.cxx )
target_link_libraries(NeighborhoodConnectedImageFilter ${ITK_LIBRARIES})

add_executable(IsolatedConnectedImageFilter IsolatedConnectedImageFilter.cxx )
target_link_libraries(IsolatedConnectedImageFilter ${ITK_LIBRARIES})

add_executable(ConnectedThresholdImageFilter ConnectedThresholdImageFilter.cxx )
target_link_libraries(ConnectedThresholdImageFilter ${ITK_LIBRARIES})

add_executable(FastMarchingImageFilter FastMarchingImageFilter.cxx )
target_link_libraries(FastMarchingImageFilter ${ITK_LIBRARIES})

add_executable(GeodesicActiveContourShapePriorLevelSetImageFilter
GeodesicActiveContourShapePriorLevelSetImageFilter.cxx )
target_link_libraries(GeodesicActiveContourShapePriorLevelSetImageFilter ${ITK_LIBRARIES})

add_executable(DeformableModel2 DeformableModel2.cxx )
target_link_libraries(DeformableModel2 ${ITK_LIBRARIES})

add_executable(GibbsPriorImageFilter1 GibbsPriorImageFilter1.cxx )
target_link_libraries(GibbsPriorImageFilter1 ${ITK_LIBRARIES})

add_executable(HoughTransform2DCirclesImageFilter HoughTransform2DCirclesImageFilter.cxx )
target_link_libraries(HoughTransform2DCirclesImageFilter ${ITK_LIBRARIES})

add_executable(HoughTransform2DLinesImageFilter HoughTransform2DLinesImageFilter.cxx )
target_link_libraries(HoughTransform2DLinesImageFilter ${ITK_LIBRARIES})

add_executable(VectorConfidenceConnected VectorConfidenceConnected.cxx )
target_link_libraries(VectorConfidenceConnected ${ITK_LIBRARIES})

add_executable(RelabelComponentImageFilter RelabelComponentImageFilter.cxx )
target_link_libraries(RelabelComponentImageFilter ${ITK_LIBRARIES})

add_executable(CannySegmentationLevelSetImageFilter CannySegmentationLevelSetImageFilter.cxx )
target_link_libraries(CannySegmentationLevelSetImageFilter ${ITK_LIBRARIES})

add_executable(GeodesicActiveContourImageFilter GeodesicActiveContourImageFilter.cxx )
target_link_libraries(GeodesicActiveContourImageFilter ${ITK_LIBRARIES})

add_executable(ShapeDetectionLevelSetFilter ShapeDetectionLevelSetFilter.cxx )
target_link_libraries(ShapeDetectionLevelSetFilter ${ITK_LIBRARIES})

add_executable(CurvesLevelSetImageFilter CurvesLevelSetImageFilter.cxx )
target_link_libraries(CurvesLevelSetImageFilter ${ITK_LIBRARIES})

add_executable(WatershedSegmentation1 WatershedSegmentation1.cxx )
target_link_libraries(WatershedSegmentation1 ${ITK_LIBRARIES})

add_executable(WatershedSegmentation2 WatershedSegmentation2.cxx )
target_link_libraries(WatershedSegmentation2 ${ITK_LIBRARIES})

add_executable(CellularSegmentation1 CellularSegmentation1.cxx )
target_link_libraries(CellularSegmentation1 ${ITK_LIBRARIES})

add_executable(CellularSegmentation2 CellularSegmentation2.cxx )
target_link_libraries(CellularSegmentation2 ${ITK_LIBRARIES})

add_executable(DeformableModel1 DeformableModel1.cxx )
target_link_libraries(DeformableModel1 ${ITK_LIBRARIES})

add_executable(LaplacianSegmentationLevelSetImageFilter LaplacianSegmentationLevelSetImageFilter.cxx )
target_link_libraries(LaplacianSegmentationLevelSetImageFilter ${ITK_LIBRARIES})

add_executable(ThresholdSegmentationLevelSetImageFilter ThresholdSegmentationLevelSetImageFilter.cxx )
target_link_libraries(ThresholdSegmentationLevelSetImageFilter ${ITK_LIBRARIES})

if(BUILD_TESTING)
  add_subdirectory(test)
endif(BUILD_TESTING)

=== Wrapping/Generators/CMakeLists.txt ===

###############################################################################
# the macros in charge of dispatching to the language specific macros

macro(itk_wrap_modules_all_generators)
#!  if(ITK_WRAP_JAVA AND WRAPPER_LIBRARY_JAVA)
#!    INIT_itk_wrap_module_java()
#!  endif(ITK_WRAP_JAVA AND WRAPPER_LIBRARY_JAVA)

  if(ITK_WRAP_PYTHON)
    itk_wrap_modules_python()
  endif(ITK_WRAP_PYTHON)
  if(ITK_WRAP_TCL)
    itk_wrap_modules_tcl()
  endif(ITK_WRAP_TCL)
  if(ITK_WRAP_JAVA)
    itk_wrap_modules_java()
  endif(ITK_WRAP_JAVA)
  if(ITK_WRAP_RUBY)
    itk_wrap_modules_ruby()
  endif(ITK_WRAP_RUBY)
endmacro(itk_wrap_modules_all_generators)

macro(itk_end_wrap_modules_all_generators)
  if(ITK_WRAP_PYTHON)
    itk_end_wrap_modules_python()
  endif(ITK_WRAP_PYTHON)
  if(ITK_WRAP_TCL)
    itk_end_wrap_modules_tcl()
  endif(ITK_WRAP_TCL)
  if(ITK_WRAP_JAVA)
    itk_end_wrap_modules_java()
  endif(ITK_WRAP_JAVA)
  if(ITK_WRAP_RUBY)
    itk_end_wrap_modules_ruby()
  endif(ITK_WRAP_RUBY)
endmacro(itk_end_wrap_modules_all_generators)


macro(itk_wrap_module_all_generators library_name)
  if(ITK_WRAP_EXPLICIT)
    itk_wrap_module_explicit("${library_name}")
  endif(ITK_WRAP_EXPLICIT)
  if(ITK_WRAP_GCCXML)
    itk_wrap_module_gccxml("${library_name}")
  endif(ITK_WRAP_GCCXML)
  if(ITK_WRAP_SWIGINTERFACE)
    itk_wrap_module_swig_interface("${library_name}")
  endif(ITK_WRAP_SWIGINTERFACE)
  if(ITK_WRAP_DOC)
    itk_wrap_module_DOC("${library_name}")
  endif(ITK_WRAP_DOC)
  if(ITK_WRAP_PYTHON AND WRAPPER_LIBRARY_PYTHON)
    itk_wrap_module_python("${library_name}")
  endif(ITK_WRAP_PYTHON AND WRAPPER_LIBRARY_PYTHON)
  if(ITK_WRAP_TCL AND WRAPPER_LIBRARY_TCL)
    itk_wrap_module_tcl("${library_name}")
  endif(ITK_WRAP_TCL AND WRAPPER_LIBRARY_TCL)
  if(ITK_WRAP_RUBY AND WRAPPER_LIBRARY_RUBY)
    itk_wrap_module_ruby("${library_name}")
  endif(ITK_WRAP_RUBY AND WRAPPER_LIBRARY_RUBY)
  if(ITK_WRAP_JAVA AND WRAPPER_LIBRARY_JAVA)
    itk_wrap_module_java("${library_name}")
  endif(ITK_WRAP_JAVA AND WRAPPER_LIBRARY_JAVA)
endmacro(itk_wrap_module_all_generators)

macro(itk_end_wrap_module_all_generators)
  if(ITK_WRAP_EXPLICIT)
    itk_end_wrap_module_explicit()
  endif(ITK_WRAP_EXPLICIT)
  if(ITK_WRAP_GCCXML)
    itk_end_wrap_module_gccxml()
  endif(ITK_WRAP_GCCXML)
  if(ITK_WRAP_SWIGINTERFACE)
    itk_end_wrap_module_swig_interface()
  endif(ITK_WRAP_SWIGINTERFACE)
  if(ITK_WRAP_PYTHON AND WRAPPER_LIBRARY_PYTHON)
    itk_end_wrap_module_python()
  endif(ITK_WRAP_PYTHON AND WRAPPER_LIBRARY_PYTHON)
  if(ITK_WRAP_TCL AND WRAPPER_LIBRARY_TCL)
    itk_end_wrap_module_tcl()
  endif(ITK_WRAP_TCL AND WRAPPER_LIBRARY_TCL)
  if(ITK_WRAP_RUBY AND WRAPPER_LIBRARY_RUBY)
    itk_end_wrap_module_ruby()
  endif(ITK_WRAP_RUBY AND WRAPPER_LIBRARY_RUBY)
  if(ITK_WRAP_JAVA AND WRAPPER_LIBRARY_JAVA)
    itk_end_wrap_module_java()
  endif(ITK_WRAP_JAVA AND WRAPPER_LIBRARY_JAVA)
  if(ITK_WRAP_DOC)
    itk_end_wrap_module_DOC()
  endif(ITK_WRAP_DOC)
endmacro(itk_end_wrap_module_all_generators)


macro(itk_wrap_submodule_all_generators module)
  if(ITK_WRAP_EXPLICIT)
    itk_wrap_submodule_explicit("${module}")
  endif(ITK_WRAP_EXPLICIT)
  if(ITK_WRAP_GCCXML)
    itk_wrap_submodule_gccxml("${module}")
  endif(ITK_WRAP_GCCXML)
  if(ITK_WRAP_SWIGINTERFACE)
    itk_wrap_submodule_swig_interface("${module}")
  endif(ITK_WRAP_SWIGINTERFACE)
  if(ITK_WRAP_DOC)
    itk_wrap_submodule_DOC("${module}")
  endif(ITK_WRAP_DOC)
  if(ITK_WRAP_PYTHON AND WRAPPER_LIBRARY_PYTHON)
    itk_wrap_submodule_python("${module}")
  endif(ITK_WRAP_PYTHON AND WRAPPER_LIBRARY_PYTHON)
  if(ITK_WRAP_TCL AND WRAPPER_LIBRARY_TCL)
    itk_wrap_submodule_tcl("${module}")
  endif(ITK_WRAP_TCL AND WRAPPER_LIBRARY_TCL)
  if(ITK_WRAP_RUBY AND WRAPPER_LIBRARY_RUBY)
    itk_wrap_submodule_ruby("${module}")
  endif(ITK_WRAP_RUBY AND WRAPPER_LIBRARY_RUBY)
  if(ITK_WRAP_JAVA AND WRAPPER_LIBRARY_JAVA)
    itk_wrap_submodule_java("${module}")
  endif(ITK_WRAP_JAVA AND WRAPPER_LIBRARY_JAVA)
endmacro(itk_wrap_submodule_all_generators)

macro(itk_end_wrap_submodule_all_generators module)
  if(ITK_WRAP_EXPLICIT)
    itk_end_wrap_submodule_explicit("${module}")
  endif(ITK_WRAP_EXPLICIT)
  if(ITK_WRAP_GCCXML)
    itk_end_wrap_submodule_gccxml("${module}")
  endif(ITK_WRAP_GCCXML)
  if(ITK_WRAP_SWIGINTERFACE)
    itk_end_wrap_submodule_swig_interface("${module}")
  endif(ITK_WRAP_SWIGINTERFACE)
  if(ITK_WRAP_PYTHON AND WRAPPER_LIBRARY_PYTHON)
    itk_end_wrap_submodule_python("${module}")
  endif(ITK_WRAP_PYTHON AND WRAPPER_LIBRARY_PYTHON)
  if(ITK_WRAP_TCL AND WRAPPER_LIBRARY_TCL)
    itk_end_wrap_submodule_tcl("${module}")
  endif(ITK_WRAP_TCL AND WRAPPER_LIBRARY_TCL)
  if(ITK_WRAP_RUBY AND WRAPPER_LIBRARY_RUBY)
    itk_end_wrap_submodule_ruby("${module}")
  endif(ITK_WRAP_RUBY AND WRAPPER_LIBRARY_RUBY)
  if(ITK_WRAP_JAVA AND WRAPPER_LIBRARY_JAVA)
    itk_end_wrap_submodule_java("${module}")
  endif(ITK_WRAP_JAVA AND WRAPPER_LIBRARY_JAVA)
  if(ITK_WRAP_DOC)
    itk_end_wrap_submodule_DOC()
  endif(ITK_WRAP_DOC)
endmacro(itk_end_wrap_submodule_all_generators)


macro(itk_wrap_class_all_generators class)
endmacro(itk_wrap_class_all_generators)

macro(itk_wrap_named_class_all_generators class swig_name)
  if(ITK_WRAP_PYTHON AND WRAPPER_LIBRARY_PYTHON)
    itk_wrap_named_class_python("${class}" "${swig_name}")
  endif(ITK_WRAP_PYTHON AND WRAPPER_LIBRARY_PYTHON)
  if(ITK_WRAP_TCL AND WRAPPER_LIBRARY_TCL)
    itk_wrap_named_class_tcl("${class}" "${swig_name}")
  endif(ITK_WRAP_TCL AND WRAPPER_LIBRARY_TCL)
  if(ITK_WRAP_RUBY AND WRAPPER_LIBRARY_RUBY)
    itk_wrap_named_class_ruby("${class}" "${swig_name}")
  endif(ITK_WRAP_RUBY AND WRAPPER_LIBRARY_RUBY)
  if(ITK_WRAP_DOC)
    itk_wrap_named_class_DOC("${class}" "${swig_name}")
  endif(ITK_WRAP_DOC)
endmacro(itk_wrap_named_class_all_generators class swig_name)

macro(itk_end_wrap_class_all_generators)
endmacro(itk_end_wrap_class_all_generators)


macro(itk_wrap_simple_class_all_generators class)
endmacro(itk_wrap_simple_class_all_generators class)


macro(itk_wrap_named_simple_class_all_generators class)
endmacro(itk_wrap_named_simple_class_all_generators class)


macro(itk_wrap_include_all_generators inc)
  if(ITK_WRAP_EXPLICIT)
    itk_wrap_include_explicit("${inc}")
  endif(ITK_WRAP_EXPLICIT)
  if(ITK_WRAP_GCCXML)
    itk_wrap_include_gccxml("${inc}")
  endif(ITK_WRAP_GCCXML)
  if(ITK_WRAP_SWIGINTERFACE)
    itk_wrap_include_swig_interface("${inc}")
  endif(ITK_WRAP_SWIGINTERFACE)
endmacro(itk_wrap_include_all_generators inc)

macro(itk_wrap_template_all_generators name types)
  if(ITK_WRAP_PYTHON AND WRAPPER_LIBRARY_PYTHON)
    itk_wrap_template_python("${name}" "${types}")
  endif(ITK_WRAP_PYTHON AND WRAPPER_LIBRARY_PYTHON)
  if(ITK_WRAP_TCL AND WRAPPER_LIBRARY_TCL)
    itk_wrap_template_tcl("${name}" "${types}")
  endif(ITK_WRAP_TCL AND WRAPPER_LIBRARY_TCL)
  if(ITK_WRAP_RUBY AND WRAPPER_LIBRARY_RUBY)
    itk_wrap_template_ruby("${name}" "${types}")
  endif(ITK_WRAP_RUBY AND WRAPPER_LIBRARY_RUBY)
endmacro(itk_wrap_template_all_generators)


macro(itk_wrap_one_type_all_generators wrap_method wrap_class swig_name template_params)
  if(ITK_WRAP_EXPLICIT)
    itk_wrap_one_type_explicit("${wrap_method}" "${wrap_class}" "${swig_name}" "${template_params}")
  endif(ITK_WRAP_EXPLICIT)
  if(ITK_WRAP_GCCXML)
    itk_wrap_one_type_gccxml("${wrap_method}" "${wrap_class}" "${swig_name}" "${template_params}")
  endif(ITK_WRAP_GCCXML)
  if(ITK_WRAP_SWIGINTERFACE)
    itk_wrap_one_type_swig_interface("${wrap_method}" "${wrap_class}" "${swig_name}" "${template_params}")
  endif(ITK_WRAP_SWIGINTERFACE)
  if(ITK_WRAP_DOC)
    itk_wrap_one_type_DOC("${wrap_method}" "${wrap_class}" "${swig_name}" "${template_params}")
  endif(ITK_WRAP_DOC)
  if(ITK_WRAP_PYTHON AND WRAPPER_LIBRARY_PYTHON)
    itk_wrap_one_type_python("${wrap_method}" "${wrap_class}" "${swig_name}" "${template_params}")
  endif(ITK_WRAP_PYTHON AND WRAPPER_LIBRARY_PYTHON)
  if(ITK_WRAP_TCL AND WRAPPER_LIBRARY_TCL)
    itk_wrap_one_type_tcl("${wrap_method}" "${wrap_class}" "${swig_name}" "${template_params}")
  endif(ITK_WRAP_TCL AND WRAPPER_LIBRARY_TCL)
  if(ITK_WRAP_RUBY AND WRAPPER_LIBRARY_RUBY)
    itk_wrap_one_type_ruby("${wrap_method}" "${wrap_class}" "${swig_name}" "${template_params}")
  endif(ITK_WRAP_RUBY AND WRAPPER_LIBRARY_RUBY)
  if(ITK_WRAP_JAVA AND WRAPPER_LIBRARY_JAVA)
    itk_wrap_one_type_java("${wrap_method}" "${wrap_class}" "${swig_name}" "${template_params}")
  endif(ITK_WRAP_JAVA AND WRAPPER_LIBRARY_JAVA)
endmacro(itk_wrap_one_type_all_generators)


macro(itk_wrap_simple_type_all_generators wrap_class swig_name)
  if(ITK_WRAP_GCCXML)
    itk_wrap_simple_type_gccxml("${wrap_class}" "${swig_name}")
  endif(ITK_WRAP_GCCXML)
  if(ITK_WRAP_PYTHON AND WRAPPER_LIBRARY_PYTHON)
    itk_wrap_simple_type_python("${wrap_class}" "${swig_name}")
  endif(ITK_WRAP_PYTHON AND WRAPPER_LIBRARY_PYTHON)
  if(ITK_WRAP_TCL AND WRAPPER_LIBRARY_TCL)
    itk_wrap_simple_type_tcl("${wrap_class}" "${swig_name}")
  endif(ITK_WRAP_TCL AND WRAPPER_LIBRARY_TCL)
  if(ITK_WRAP_RUBY AND WRAPPER_LIBRARY_RUBY)
    itk_wrap_simple_type_ruby("${wrap_class}" "${swig_name}")
  endif(ITK_WRAP_RUBY AND WRAPPER_LIBRARY_RUBY)
  if(ITK_WRAP_JAVA AND WRAPPER_LIBRARY_JAVA)
    itk_wrap_simple_type_java("${wrap_class}" "${swig_name}")
  endif(ITK_WRAP_JAVA AND WRAPPER_LIBRARY_JAVA)
endmacro(itk_wrap_simple_type_all_generators wrap_class swig_name)



###############################################################################
# ccache management. This option is shared by most of generators, so put it here.
option(ITK_USE_CCACHE "Use ccache to cache swig/gccxml/... output and speedup the rebuild." OFF)
mark_as_advanced(ITK_USE_CCACHE)
if(ITK_USE_CCACHE)
  find_program(CCACHE_EXECUTABLE NAMES ccache-swig ccache DOC "ccache executable.")
endif(ITK_USE_CCACHE)



###############################################################################
# build the generators list

if(EXTERNAL_WRAP_ITK_PROJECT)
  # generators there have been turned on while building wrapitk
  set(default ON)
else(EXTERNAL_WRAP_ITK_PROJECT)
  # set some of them to on by default
  option(ITK_WRAP_GCCXML "Build gccxml files." ON)
  option(ITK_WRAP_SWIGINTERFACE "Build swig interfaces." ON)
  set(default OFF)
endif(EXTERNAL_WRAP_ITK_PROJECT)

set(WRAP_ITK_GENERATORS CACHE INTERNAL "Internal generators list.")
set(WRAP_ITK_UNUSED_GENERATORS CACHE INTERNAL "Internal unused generators list.")
file(GLOB local_files *)
# filter and reorder the list
set(generators )
foreach(f ${local_files})
  file(RELATIVE_PATH lang "${CMAKE_CURRENT_SOURCE_DIR}" "${f}")
  if(IS_DIRECTORY "${f}" AND NOT "${lang}" MATCHES "CVS" AND NOT "${lang}" MATCHES ".svn")
    if("${lang}" MATCHES "^GccXML$|^SwigInterface$|^Doc$")
      # put those generators before the others
      set(generators ${lang} ${generators})
    else("${lang}" MATCHES "^GccXML$|^SwigInterface$|^Doc$")
      set(generators ${generators} ${lang})
    endif("${lang}" MATCHES "^GccXML$|^SwigInterface$|^Doc$")
  endif(IS_DIRECTORY "${f}" AND NOT "${lang}" MATCHES "CVS" AND NOT "${lang}" MATCHES ".svn")
endforeach(f)

foreach(lang ${generators})
  string(TOUPPER "${lang}" lang_upper)

  # add the language to the options
  option(ITK_WRAP_${lang_upper} "Build swig ${lang} wrapper support." ${default})

  # add the language to the list, if the user have turn it on, and include
  # the subdirectory
  if(ITK_WRAP_${lang_upper})
    set(WRAP_ITK_GENERATORS ${WRAP_ITK_GENERATORS} "${lang}")
    add_subdirectory("${lang}")
    get_directory_property(inc DIRECTORY "${lang}" INCLUDE_DIRECTORIES)
    include_directories(${inc})
  else(ITK_WRAP_${lang_upper})
    set(WRAP_ITK_UNUSED_GENERATORS ${WRAP_ITK_UNUSED_GENERATORS} "${lang}")
  endif(ITK_WRAP_${lang_upper})
endforeach(lang)
set(WRAP_ITK_GENERATORS ${WRAP_ITK_GENERATORS} CACHE INTERNAL "Internal generators list.")
set(WRAP_ITK_UNUSED_GENERATORS ${WRAP_ITK_UNUSED_GENERATORS} CACHE INTERNAL "Internal unused generators list.")

=== Wrapping/Modules/CMakeLists.txt ===

unset(WRAP_ITK_MODULES CACHE)

foreach(m ${ITK_CONFIG_MODULES_ENABLED})
  if(EXISTS "${${m}_SOURCE_DIR}/wrapping/CMakeLists.txt")
    set(WRAP_ITK_MODULES ${WRAP_ITK_MODULES} ${m})
    add_subdirectory("${${m}_SOURCE_DIR}/wrapping" ${CMAKE_CURRENT_BINARY_DIR}/${m})
  endif()
endforeach(m)
set(WRAP_ITK_MODULES ${WRAP_ITK_MODULES} CACHE INTERNAL "Internal library list.")

=== Examples/DataRepresentation/Mesh/CMakeLists.txt ===
project(MeshExamples)
include_regular_expression("^.*$")

add_executable(PointSet1 PointSet1.cxx )
target_link_libraries(PointSet1 ${ITK_LIBRARIES})

add_executable(PointSet2 PointSet2.cxx )
target_link_libraries(PointSet2 ${ITK_LIBRARIES})

add_executable(PointSet3 PointSet3.cxx )
target_link_libraries(PointSet3 ${ITK_LIBRARIES})

add_executable(RGBPointSet RGBPointSet.cxx )
target_link_libraries(RGBPointSet ${ITK_LIBRARIES})

add_executable(PointSetWithVectors PointSetWithVectors.cxx )
target_link_libraries(PointSetWithVectors ${ITK_LIBRARIES})

add_executable(PointSetWithCovariantVectors PointSetWithCovariantVectors.cxx )
target_link_libraries(PointSetWithCovariantVectors ${ITK_LIBRARIES})

add_executable(Mesh1 Mesh1.cxx )
target_link_libraries(Mesh1 ${ITK_LIBRARIES})

add_executable(Mesh2 Mesh2.cxx )
target_link_libraries(Mesh2 ${ITK_LIBRARIES})

add_executable(Mesh3 Mesh3.cxx )
target_link_libraries(Mesh3 ${ITK_LIBRARIES})

add_executable(MeshTraits MeshTraits.cxx )
target_link_libraries(MeshTraits ${ITK_LIBRARIES})

add_executable(MeshKComplex MeshKComplex.cxx )
target_link_libraries(MeshKComplex ${ITK_LIBRARIES})

add_executable(MeshPolyLine MeshPolyLine.cxx )
target_link_libraries(MeshPolyLine ${ITK_LIBRARIES})

add_executable(MeshCellsIteration MeshCellsIteration.cxx )
target_link_libraries(MeshCellsIteration ${ITK_LIBRARIES})

add_executable(MeshCellVisitor MeshCellVisitor.cxx )
target_link_libraries(MeshCellVisitor ${ITK_LIBRARIES})

add_executable(MeshCellVisitor2 MeshCellVisitor2.cxx )
target_link_libraries(MeshCellVisitor2 ${ITK_LIBRARIES})

add_executable(AutomaticMesh AutomaticMesh.cxx )
target_link_libraries(AutomaticMesh ${ITK_LIBRARIES})

add_executable(ImageToPointSet ImageToPointSet.cxx )
target_link_libraries(ImageToPointSet ${ITK_LIBRARIES})


if(BUILD_TESTING)
  add_subdirectory(test)
endif(BUILD_TESTING)

=== Examples/DataRepresentation/Path/CMakeLists.txt ===
project(PathExamples)
include_regular_expression("^.*$")


add_executable(PolyLineParametricPath1 PolyLineParametricPath1.cxx )
target_link_libraries(PolyLineParametricPath1 ${ITK_LIBRARIES})

if(BUILD_TESTING)
  add_subdirectory(test)
endif(BUILD_TESTING)

=== Examples/Filtering/test/CMakeLists.txt ===
set(BASELINE ${ITK_DATA_ROOT}/Baseline/Filtering)
set(TEMP ${ITK_BINARY_DIR}/Testing/Temporary)

itk_add_test(NAME BilateralImageFilterTest COMMAND ${ITK_TEST_DRIVER}
  --compare DATA{${BASELINE}/BilateralImageFilter.png}
            ${TEMP}/BilateralImageFilter.png
  $<TARGET_FILE:BilateralImageFilter>
        ${ITK_SOURCE_DIR}/Examples/Data/BrainProtonDensitySlice.png
        ${TEMP}/BilateralImageFilter.png
        6.0 5.0
)
itk_add_test(NAME  BinaryMinMaxCurvatureFlowImageFilterTest COMMAND ${ITK_TEST_DRIVER}
  --compare DATA{${BASELINE}/BinaryMinMaxCurvatureFlowImageFilter.png}
            ${TEMP}/BinaryMinMaxCurvatureFlowImageFilter.png
  $<TARGET_FILE:BinaryMinMaxCurvatureFlowImageFilter>
        ${ITK_SOURCE_DIR}/Examples/Data/BrainProtonDensitySlice.png
        ${TEMP}/BinaryMinMaxCurvatureFlowImageFilter.png
        10 .125 1 128
)
itk_add_test(NAME  BinaryThresholdImageFilterTest COMMAND ${ITK_TEST_DRIVER}
  --compare DATA{${BASELINE}/BinaryThresholdImageFilter.png}
            ${TEMP}/BinaryThresholdImageFilter.png
  $<TARGET_FILE:BinaryThresholdImageFilter>
        ${ITK_SOURCE_DIR}/Examples/Data/BrainProtonDensitySlice.png
        ${TEMP}/BinaryThresholdImageFilter.png
        150 180 0 255
)
itk_add_test(NAME  BinaryMedianImageFilterTest1 COMMAND ${ITK_TEST_DRIVER}
  --compare DATA{${BASELINE}/BinaryMedianImageFilter1.png}
            ${TEMP}/BinaryMedianImageFilter1.png
  $<TARGET_FILE:BinaryMedianImageFilter>
        DATA{${BASELINE}/BinaryThresholdImageFilter.png}
        ${TEMP}/BinaryMedianImageFilter1.png
        1 1
)
itk_add_test(NAME  BinaryMedianImageFilterTest2 COMMAND ${ITK_TEST_DRIVER}
  --compare DATA{${BASELINE}/BinaryMedianImageFilter2.png}
            ${TEMP}/BinaryMedianImageFilter2.png
  $<TARGET_FILE:BinaryMedianImageFilter>
        DATA{${BASELINE}/BinaryThresholdImageFilter.png}
        ${TEMP}/BinaryMedianImageFilter2.png
        2 2
)
itk_add_test(NAME  BinaryMedianImageFilterTest3 COMMAND ${ITK_TEST_DRIVER}
  --compare DATA{${BASELINE}/BinaryMedianImageFilter3.png}
            ${TEMP}/BinaryMedianImageFilter3.png
  $<TARGET_FILE:BinaryMedianImageFilter>
        DATA{${BASELINE}/BinaryThresholdImageFilter.png}
        ${TEMP}/BinaryMedianImageFilter3.png
        3 3
)
itk_add_test(NAME  VotingBinaryHoleFillingImageFilterTest1 COMMAND ${ITK_TEST_DRIVER}
  --compare DATA{${BASELINE}/VotingBinaryHoleFillingImageFilter1.png}
            ${TEMP}/VotingBinaryHoleFillingImageFilter1.png
  $<TARGET_FILE:VotingBinaryHoleFillingImageFilter>
        DATA{${BASELINE}/BinaryThresholdImageFilter.png}
        ${TEMP}/VotingBinaryHoleFillingImageFilter1.png
        1 1
)
itk_add_test(NAME  VotingBinaryHoleFillingImageFilterTest2 COMMAND ${ITK_TEST_DRIVER}
  --compare DATA{${BASELINE}/VotingBinaryHoleFillingImageFilter2.png}
            ${TEMP}/VotingBinaryHoleFillingImageFilter2.png
  $<TARGET_FILE:VotingBinaryHoleFillingImageFilter>
        DATA{${BASELINE}/BinaryThresholdImageFilter.png}
        ${TEMP}/VotingBinaryHoleFillingImageFilter2.png
        2 2
)
itk_add_test(NAME  VotingBinaryHoleFillingImageFilterTest3 COMMAND ${ITK_TEST_DRIVER}
  --compare DATA{${BASELINE}/VotingBinaryHoleFillingImageFilter3.png}
            ${TEMP}/VotingBinaryHoleFillingImageFilter3.png
  $<TARGET_FILE:VotingBinaryHoleFillingImageFilter>
        DATA{${BASELINE}/BinaryThresholdImageFilter.png}
        ${TEMP}/VotingBinaryHoleFillingImageFilter3.png
        3 3
)
itk_add_test(NAME  VotingBinaryIterativeHoleFillingImageFilterTest1 COMMAND ${ITK_TEST_DRIVER}
  --compare DATA{${BASELINE}/VotingBinaryIterativeHoleFillingImageFilter1.png}
            ${TEMP}/VotingBinaryIterativeHoleFillingImageFilter1.png
  $<TARGET_FILE:VotingBinaryIterativeHoleFillingImageFilter>
        DATA{${BASELINE}/BinaryThresholdImageFilter.png}
        ${TEMP}/VotingBinaryIterativeHoleFillingImageFilter1.png
        1 1 10
)
itk_add_test(NAME  VotingBinaryIterativeHoleFillingImageFilterTest2 COMMAND ${ITK_TEST_DRIVER}
  --compare DATA{${BASELINE}/VotingBinaryIterativeHoleFillingImageFilter2.png}
            ${TEMP}/VotingBinaryIterativeHoleFillingImageFilter2.png
  $<TARGET_FILE:VotingBinaryIterativeHoleFillingImageFilter>
        DATA{${BASELINE}/BinaryThresholdImageFilter.png}
        ${TEMP}/VotingBinaryIterativeHoleFillingImageFilter2.png
        2 2 10
)
itk_add_test(NAME  VotingBinaryIterativeHoleFillingImageFilterTest3 COMMAND ${ITK_TEST_DRIVER}
  --compare DATA{${BASELINE}/VotingBinaryIterativeHoleFillingImageFilter3.png}
            ${TEMP}/VotingBinaryIterativeHoleFillingImageFilter3.png
  $<TARGET_FILE:VotingBinaryIterativeHoleFillingImageFilter>
        DATA{${BASELINE}/BinaryThresholdImageFilter.png}
        ${TEMP}/VotingBinaryIterativeHoleFillingImageFilter3.png
        3 3 10
)
itk_add_test(NAME  BinomialBlurImageFilterTest COMMAND ${ITK_TEST_DRIVER}
  --compare DATA{${BASELINE}/BinomialBlurImageFilter.png}
            ${TEMP}/BinomialBlurImageFilter.png
  $<TARGET_FILE:BinomialBlurImageFilter>
        ${ITK_SOURCE_DIR}/Examples/Data/BrainProtonDensitySlice.png
        ${TEMP}/BinomialBlurImageFilter.png
        5
)
itk_add_test(NAME  CompositeFilterExampleTest COMMAND ${ITK_TEST_DRIVER}
  --compare DATA{Baseline/CompositeFilterExample.mha}
            ${TEMP}/CompositeFilterExample.mha
  $<TARGET_FILE:CompositeFilterExample>
        ${ITK_SOURCE_DIR}/Examples/Data/BrainProtonDensitySlice.png
        ${TEMP}/CompositeFilterExample.mha
)
itk_add_test(NAME  CurvatureAnisotropicDiffusionImageFilterTest COMMAND ${ITK_TEST_DRIVER}
  --compare DATA{${BASELINE}/CurvatureAnisotropicDiffusionImageFilter.png}
            ${TEMP}/CurvatureAnisotropicDiffusionImageFilter.png
  $<TARGET_FILE:CurvatureAnisotropicDiffusionImageFilter>
        ${ITK_SOURCE_DIR}/Examples/Data/BrainProtonDensitySlice.png
        ${TEMP}/CurvatureAnisotropicDiffusionImageFilter.png
        5 0.125 3
)
itk_add_test(NAME  CurvatureFlowImageFilterTest COMMAND ${ITK_TEST_DRIVER}
  --compare DATA{${BASELINE}/CurvatureFlowImageFilter.png}
            ${TEMP}/CurvatureFlowImageFilter.png
  $<TARGET_FILE:CurvatureFlowImageFilter>
        ${ITK_SOURCE_DIR}/Examples/Data/BrainProtonDensitySlice.png
        ${TEMP}/CurvatureFlowImageFilter.png
        5 0.125 1.0
)
itk_add_test(NAME  DanielssonDistanceMapImageFilterTest COMMAND ${ITK_TEST_DRIVER}
  --compare DATA{${BASELINE}/DanielssonDistanceMapImageFilter.png}
            ${TEMP}/DanielssonDistanceMapImageFilter.png
  $<TARGET_FILE:DanielssonDistanceMapImageFilter>
        ${ITK_SOURCE_DIR}/Examples/Data/FivePoints.png
        ${TEMP}/DanielssonDistanceMapImageFilter.png
        ${TEMP}/DanielssonDistanceMapImageFilter2.png
        ${TEMP}/DanielssonDistanceMapImageFilter.mha
)
itk_add_test(NAME  DiscreteGaussianImageFilterTest COMMAND ${ITK_TEST_DRIVER}
  --compare DATA{${BASELINE}/DiscreteGaussianImageFilter.png}
            ${TEMP}/DiscreteGaussianImageFilter.png
  $<TARGET_FILE:DiscreteGaussianImageFilter>
        ${ITK_SOURCE_DIR}/Examples/Data/BrainProtonDensitySlice.png
        ${TEMP}/DiscreteGaussianImageFilter.png
        1.73 10
)
itk_add_test(NAME  GradientAnisotropicDiffusionImageFilterTest COMMAND ${ITK_TEST_DRIVER}
  --compare DATA{${BASELINE}/GradientAnisotropicDiffusionImageFilter.png}
            ${TEMP}/GradientAnisotropicDiffusionImageFilter.png
  $<TARGET_FILE:GradientAnisotropicDiffusionImageFilter>
        ${ITK_SOURCE_DIR}/Examples/Data/BrainProtonDensitySlice.png
        ${TEMP}/GradientAnisotropicDiffusionImageFilter.png
        5 0.125 1.0
)
itk_add_test(NAME  GradientMagnitudeImageFilterTest COMMAND ${ITK_TEST_DRIVER}
  --compare DATA{${BASELINE}/GradientMagnitudeImageFilter.png}
            ${TEMP}/GradientMagnitudeImageFilter.png
  $<TARGET_FILE:GradientMagnitudeImageFilter>
        ${ITK_SOURCE_DIR}/Examples/Data/BrainProtonDensitySlice.png
        ${TEMP}/GradientMagnitudeImageFilter.png
)
itk_add_test(NAME  GradientMagnitudeRecursiveGaussianImageFilterTest COMMAND ${ITK_TEST_DRIVER}
  --compare DATA{${BASELINE}/GradientMagnitudeRecursiveGaussianImageFilter.png}
            ${TEMP}/GradientMagnitudeRecursiveGaussianImageFilter.png
  $<TARGET_FILE:GradientMagnitudeRecursiveGaussianImageFilter>
        ${ITK_SOURCE_DIR}/Examples/Data/BrainProtonDensitySlice.png
        ${TEMP}/GradientMagnitudeRecursiveGaussianImageFilter.png
        5
)
itk_add_test(NAME  GradientRecursiveGaussianImageFilterTest COMMAND ${ITK_TEST_DRIVER}
  $<TARGET_FILE:GradientRecursiveGaussianImageFilter>
        DATA{${ITK_SOURCE_DIR}/Testing/Data/Input/HeadMRVolume.mhd,HeadMRVolume.raw}
        ${TEMP}/GradientRecursiveGaussianImageFilterTest.mha
        1.5  # Sigma
)
itk_add_test(NAME  GradientVectorFlowImageFilterTest COMMAND ${ITK_TEST_DRIVER}
  $<TARGET_FILE:GradientVectorFlowImageFilter>
        DATA{${ITK_SOURCE_DIR}/Testing/Data/Input/GradientRecursiveGaussianImageFilterTest.mha}
        ${TEMP}/GradientVectorFlowImageFilterTest.mha
        5        # number of iterations
        2000.0   # noise level
)
set_tests_properties( GradientVectorFlowImageFilterTest
  PROPERTIES DEPENDS GradientRecursiveGaussianImageFilterTest)
itk_add_test(NAME  DerivativeImageFilterTest COMMAND ${ITK_TEST_DRIVER}
  --compare DATA{${BASELINE}/DerivativeImageFilter.mha}
            ${TEMP}/DerivativeImageFilter.mha
  $<TARGET_FILE:DerivativeImageFilter>
        ${ITK_SOURCE_DIR}/Examples/Data/BrainProtonDensitySlice.png
        ${TEMP}/DerivativeImageFilter.mha
        ${TEMP}/DerivativeImageFilter.png
        1 1
)
itk_add_test(NAME  LaplacianImageFilterTest COMMAND ${ITK_TEST_DRIVER}
  --compare DATA{${BASELINE}/LaplacianImageFilter.png}
            ${TEMP}/LaplacianImageFilter.png
  $<TARGET_FILE:LaplacianImageFilter>
        ${ITK_SOURCE_DIR}/Examples/Data/BrainProtonDensitySlice.png
        ${TEMP}/LaplacianImageFilter.png
)
itk_add_test(NAME  LaplacianSharpeningImageFilterTest COMMAND ${ITK_TEST_DRIVER}
  --compare DATA{${BASELINE}/LaplacianSharpeningImageFilter.png}
            ${TEMP}/LaplacianSharpeningImageFilter.png
  $<TARGET_FILE:LaplacianSharpeningImageFilter>
        DATA{${ITK_SOURCE_DIR}/Testing/Data/Input/cthead1.png}
        ${TEMP}/LaplacianSharpeningImageFilter.png
)
itk_add_test(NAME  MathematicalMorphologyBinaryFiltersTest COMMAND ${ITK_TEST_DRIVER}
  --compare DATA{${BASELINE}/MathematicalMorphologyBinaryFiltersErode.png}
            ${TEMP}/MathematicalMorphologyBinaryFiltersErode.png
  $<TARGET_FILE:MathematicalMorphologyBinaryFilters>
        ${ITK_SOURCE_DIR}/Examples/Data/BrainProtonDensitySlice.png
        ${TEMP}/MathematicalMorphologyBinaryFiltersErode.png
        ${TEMP}/MathematicalMorphologyBinaryFiltersDilate.png
        150 180
)
itk_add_test(NAME  MathematicalMorphologyGrayscaleFiltersTest COMMAND ${ITK_TEST_DRIVER}
  --compare DATA{${BASELINE}/MathematicalMorphologyGrayscaleFiltersErode.png}
            ${TEMP}/MathematicalMorphologyGrayscaleFiltersErode.png
  $<TARGET_FILE:MathematicalMorphologyGrayscaleFilters>
        ${ITK_SOURCE_DIR}/Examples/Data/BrainProtonDensitySlice.png
        ${TEMP}/MathematicalMorphologyGrayscaleFiltersErode.png
        ${TEMP}/MathematicalMorphologyGrayscaleFiltersDilate.png
)
itk_add_test(NAME  MeanImageFilterTest COMMAND ${ITK_TEST_DRIVER}
  --compare DATA{${BASELINE}/MeanImageFilter.png}
            ${TEMP}/MeanImageFilter.png
  $<TARGET_FILE:MeanImageFilter>
        ${ITK_SOURCE_DIR}/Examples/Data/BrainProtonDensitySlice.png
        ${TEMP}/MeanImageFilter.png
)
itk_add_test(NAME  MedianImageFilterTest COMMAND ${ITK_TEST_DRIVER}
  --compare DATA{${BASELINE}/MedianImageFilter.png}
            ${TEMP}/MedianImageFilter.png
  $<TARGET_FILE:MedianImageFilter>
        ${ITK_SOURCE_DIR}/Examples/Data/BrainProtonDensitySlice.png
        ${TEMP}/MedianImageFilter.png
        1
)
itk_add_test(NAME  ResampleImageFilterTest1 COMMAND ${ITK_TEST_DRIVER}
  --compare DATA{${BASELINE}/ResampleImageFilterTest1.png}
            ${TEMP}/ResampleImageFilterTest1.png
  $<TARGET_FILE:ResampleImageFilter>

=== Examples/IO/test/CMakeLists.txt ===
set(BASELINE ${ITK_DATA_ROOT}/Baseline/Registration)
set(TEMP ${ITK_BINARY_DIR}/Testing/Temporary)

if(ITK_VISIBLEHUMAN_DATA_ROOT)
  itk_add_test(NAME VisibleHumanStreamReadWriteTest
    COMMAND ${ITK_TEST_DRIVER}
   $<TARGET_FILE:VisibleHumanStreamReadWrite>
    ${ITK_VISIBLEHUMAN_DATA_ROOT}/Male/Fullcolor/fullbody/
    ${TEMP}/VisibleHumanStreamReadWrite.mha )
  itk_add_test(NAME VisibleHumanPasteWriteTest
    COMMAND ${ITK_TEST_DRIVER}
   $<TARGET_FILE:VisibleHumanPasteWrite>
    ${TEMP}/VisibleHumanStreamReadWrite.mha
    ${TEMP}/VisibleHumanPasteWrite.mha)
  # this test must be run sequentially, be cause the output of the first is used by the second
  set_tests_properties(
    VisibleHumanStreamReadWriteTest
    PROPERTIES
    RUN_SERIAL 1
    )
  set_tests_properties(
    VisibleHumanPasteWriteTest
    PROPERTIES
    DEPENDS VisibleHumanStreamReadWriteTest
    )
endif(ITK_VISIBLEHUMAN_DATA_ROOT)

=== debian/changelog ===
insighttoolkit4 (4.1.0-1) experimental; urgency=low

  * New upstream release.
    patches/gzgetc.patch: Remove.  Applied upstream.

 -- Steve M. Robbins <smr@debian.org>  Sat, 03 Mar 2012 20:31:43 -0600

insighttoolkit4 (4.0.0-1) experimental; urgency=low

  * New upstream, major release.  Removed all patches.
  
  * rules: Reworked CMAKE_FLAGS from scratch.  Update for new install
    practice: libs in /usr/lib, includes in /usr/include/ITK-4.0.
  
  * patches/gzgetc.patch: New.  Fix to build with zlib where gzgetc is a
    macro.

 -- Steve M. Robbins <smr@debian.org>  Thu, 26 Jan 2012 20:42:39 -0600

insighttoolkit (3.20.1-2) unstable; urgency=low

  [ Mathieu Malaterre ]

  * rules: Use system installed VXL
  * control.in: Add myself as uploader.  

  [ Steve M. Robbins ]
  
  * control.in: -dev package depends on libgdcm2-dev.  Closes: #587589

 -- Steve M. Robbins <smr@debian.org>  Sat, 21 Jan 2012 12:23:58 -0600

insighttoolkit (3.20.1-1) unstable; urgency=low

  * New upstream.
    - patches/metaio-test-vtk_source.patch:
    - patches/ptrdiff.patch: Remove.  Applied upstream.

 -- Steve M. Robbins <smr@debian.org>  Thu, 27 Oct 2011 22:24:59 -0500

insighttoolkit (3.20.0-17) unstable; urgency=low

  * rules: Make example files permission fix conditional on installing
    $(pkg_examples).

 -- Steve M. Robbins <smr@debian.org>  Sat, 17 Sep 2011 22:21:18 -0500

insighttoolkit (3.20.0-16) unstable; urgency=low

  * Remove language wrappings.  New source packages, one per wrapped
    language will be introduced to build the wrappings.  
  * Build in Release mode for full -O3 optimization.  
  * Build in parallel.
  * Use debhelper instead of cdbs.

 -- Steve M. Robbins <smr@debian.org>  Sat, 17 Sep 2011 12:31:22 -0500

insighttoolkit (3.20.0-15) unstable; urgency=low

  * control.in: Restore build-dependency on libtiff4-dev (fails to
  build with libtiff5).

 -- Steve M. Robbins <smr@debian.org>  Sun, 11 Sep 2011 18:02:04 -0500

insighttoolkit (3.20.0-14) experimental; urgency=low

  * control.in:
  * rules: Follow upstream to install python wrapping into
    /usr/lib/InsightToolkit, with WrapITK.pth in dist-packages.  Switch to
    dh_python2.

  * rules: Change build type from RELEASE to RelWithDebInfo.  This reduces
    optimization from -O3 to -O2 which should help with excessive memory
    usage during build (see #640667).

 -- Steve M. Robbins <smr@debian.org>  Sat, 10 Sep 2011 14:45:13 -0500

insighttoolkit (3.20.0-13) unstable; urgency=low

  * Remove absolute paths to required libraries from
    /usr/lib/InsightToolkit/ITKLibraryDepends.cmake after building,
    closes: #635300.  Due to the multiarch transition, the original
    behavior frequently causes reverse build-deps to FTBFS.  This change
    should probably be reverted once all required libraries are
    multiarched.

 -- Michael Schutte <michi@debian.org>  Tue, 16 Aug 2011 20:52:58 +0200

insighttoolkit (3.20.0-12) unstable; urgency=low

  * patches/itkImageToImageFilterC.patch: Remove.
  * patches/wrap-iifilter-split.patch: New; replaces above patch.  Split
    itkImageToImageFilterB into 3 files, introducing FilterC and FilterD.

 -- Steve M. Robbins <smr@debian.org>  Fri, 12 Aug 2011 20:08:27 -0500

insighttoolkit (3.20.0-11) unstable; urgency=low

  * control: Build-depend on newer gccxml that removes "inline namespace"
    from c++config.h.  Closes: #632582.

 -- Steve M. Robbins <smr@debian.org>  Sun, 24 Jul 2011 00:16:22 -0500

insighttoolkit (3.20.0-10) unstable; urgency=low

  * patches/ptrdiff.patch.  New.  Include <stddef.h> to ensure ptrdiff_t
    is defined.  Closes: #625077, #624941, #625090.
  
  * rules: Enable optimized registration methods and transform IO
    factories.  Closes: #614519.
  
  * patches/tcl-install.patch: Set WRAP_ITK_PACKAGE_DIR to /usr/lib.
    Closes: #618736.
  
  * control: Build-depend on newer gccxml.

 -- Steve M. Robbins <smr@debian.org>  Fri, 06 May 2011 01:31:04 -0500

insighttoolkit (3.20.0-9) unstable; urgency=low

  * control: Build-depend on newer gccxml and cableswig.

 -- Steve M. Robbins <smr@debian.org>  Sun, 06 Mar 2011 15:11:09 -0600

insighttoolkit (3.20.0-8) unstable; urgency=low

  * rules: Remove parallel build.

 -- Steve M. Robbins <smr@debian.org>  Wed, 16 Feb 2011 00:44:55 -0600

insighttoolkit (3.20.0-7) unstable; urgency=low

  * patches/itkImageToImageFilterC.patch: New.  Split the
    ImageToImageFilter into smaller modules to avoid compiler table
    overflow (build failure).
  
  * rules: Try parallel build again.
  
 -- Steve M. Robbins <smr@debian.org>  Sat, 12 Feb 2011 20:04:44 -0600

insighttoolkit (3.20.0-6) unstable; urgency=low

  [Paul Novotny]
  * control:
  * rules:
  * patches/wrapitk-externalprojects.patch: New.  Add two External
    Projects to the WrapITK build. PyBuffer provides easy interoperability
    with numpy. ItkVtkGlue makes it easy to convert from and to VTK.
  
  * rules: Turn off wrapping 4D images, fix wrap setting misspellings.
  
  * patches/add-registration-optimizers.patch: New.  Add a couple new
    registration optimizers, including LBFGSBOptimizer used for B-spline
    3D registration.  Add a few array types to use the optimizers
    correctly.
  
  [Steve Robbins]
  * control: Add build-deps on libvtk5-dev, python-vtk for ItkVtkGlue.
    Remove unnecessary build-deps libjpeg62-dev, libtiff4-dev,
    libfreetype6-dev, libopenjpeg-dev, graphviz, libxext-dev, libxss-dev,
    libxft-dev, libpoppler-dev, libssl-dev.  Closes: #608394.

 -- Steve M. Robbins <smr@debian.org>  Mon, 07 Feb 2011 01:35:06 -0600

insighttoolkit (3.20.0-5) experimental; urgency=low

  * patches/wrapitk.patch: New.  Use ITK_LIBRARY_PROPERTIES to properly
    version libSwigRuntime{Python,Java,Tcl} and the Tcl shared libs (which
    are installed in /usr/lib).

  * rules: Install libSwigJava into /usr/lib.

 -- Steve M. Robbins <smr@debian.org>  Wed, 22 Dec 2010 23:32:20 -0600

insighttoolkit (3.20.0-4) experimental; urgency=low



=== debian/control ===
Source: insighttoolkit4
Homepage: http://www.itk.org/
Section: science
Priority: optional
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
DM-Upload-Allowed: yes
Uploaders: Steve M. Robbins <smr@debian.org>, Mathieu Malaterre <mathieu.malaterre@gmail.com>
Build-Depends: debhelper (>= 8),
 cmake, cableswig (>= 0.1.0+cvs20110226), gccxml (>= 0.9.0+cvs20110723),
 zlib1g-dev (>= 1.2.2), libpng12-dev, libvxl1-dev,
 libfftw3-dev, libgeotiff-dev,
 uuid-dev, libgdcm2-dev, libminc-dev, libhdf5-dev,
 libvtk5-dev, python-vtk
Standards-Version: 3.9.2
Vcs-Browser: http://anonscm.debian.org/viewvc/debian-med/trunk/packages/insighttoolkit/trunk/
Vcs-Svn: svn://svn.debian.org/debian-med/trunk/packages/insighttoolkit/trunk/

Package: libinsighttoolkit4.1
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Image processing toolkit for registration and segmentation - runtime
 ITK is an open-source software toolkit for performing registration and
 segmentation. Segmentation is the process of identifying and
 classifying data found in a digitally sampled
 representation. Typically the sampled representation is an image
 acquired from such medical instrumentation as CT or MRI
 scanners. Registration is the task of aligning or developing
 correspondences between data. For example, in the medical
 environment, a CT scan may be aligned with a MRI scan in order to
 combine the information contained in both.
 .
 This package contains the libraries needed to run ITK applications.

Package: libinsighttoolkit4-dev
Section: libdevel
Architecture: any
Depends: ${misc:Depends}, libinsighttoolkit4.1 (= ${binary:Version}), libgdcm2-dev
Recommends: libfftw3-dev, uuid-dev
Conflicts: libinsighttoolkit-dev
Replaces: libinsighttoolkit-dev
Suggests: insighttoolkit4-examples
Description: Image processing toolkit for registration and segmentation - development
 ITK is an open-source software toolkit for performing registration and
 segmentation. Segmentation is the process of identifying and
 classifying data found in a digitally sampled
 representation. Typically the sampled representation is an image
 acquired from such medical instrumentation as CT or MRI
 scanners. Registration is the task of aligning or developing
 correspondences between data. For example, in the medical
 environment, a CT scan may be aligned with a MRI scan in order to
 combine the information contained in both.
 .
 This package contains the development files needed to build your own
 ITK applications.

Package: insighttoolkit4-examples
Section: devel
Architecture: all
Depends: ${misc:Depends}, ${shlibs:Depends}
Suggests: libinsighttoolkit4-dev
Conflicts: insighttoolkit-examples
Replaces: insighttoolkit-examples
Description: Image processing toolkit for registration and segmentation - examples
 ITK is an open-source software toolkit for performing registration and
 segmentation. Segmentation is the process of identifying and
 classifying data found in a digitally sampled
 representation. Typically the sampled representation is an image
 acquired from such medical instrumentation as CT or MRI
 scanners. Registration is the task of aligning or developing
 correspondences between data. For example, in the medical
 environment, a CT scan may be aligned with a MRI scan in order to
 combine the information contained in both.
 .
 This package contains the source for example programs.

=== debian/rules ===
#!/usr/bin/make -f

VER_MAJOR = 4
VER_MINOR = 1
VER_PATCH = 0

# TODO: turn on the following:
#
# system HDF5 (omits C++ bindings; Bug #660547)
# system TIFF (requires version 4, but libvtk5-dev depends on version 3)
# system VXL (Bug #656837)
# Module_ITKLevelSetsv4Visualization (https://issues.itk.org/jira/browse/ITK-2856)
# Module_ITKVideoBridgeOpenCV (undiagnosed build error)
# Module_ITKVideoBridgeVXL (undiagnosed build error)
# Module_ITKVtkGlue (https://issues.itk.org/jira/browse/ITK-2856)

CMAKE_FLAGS = \
	-DCMAKE_VERBOSE_MAKEFILE:BOOL=ON \
	-DBUILD_SHARED_LIBS:BOOL=ON \
	-DCMAKE_EXPORT_COMPILE_COMMANDS:BOOL=ON \
	-DCMAKE_SKIP_RPATH:BOOL=ON \
	-DCMAKE_VERBOSE_MAKEFILE:BOOL=ON \
	-DITKV3_COMPATIBILITY:BOOL=ON \
	-DITK_USE_MINC2:BOOL=ON \
	-DITK_USE_STRICT_CONCEPT_CHECKING:BOOL=ON \
	-DITK_USE_SYSTEM_GDCM:BOOL=ON \
	-DITK_USE_SYSTEM_HDF5:BOOL=OFF \
	-DITK_USE_SYSTEM_JPEG:BOOL=ON \
	-DITK_USE_SYSTEM_PNG:BOOL=ON \
	-DITK_USE_SYSTEM_TIFF:BOOL=OFF \
	-DITK_USE_SYSTEM_VXL:BOOL=OFF \
	-DITK_USE_SYSTEM_ZLIB:BOOL=ON \
	-DModule_ITKIOPhilipsREC:BOOL=ON \
	-DModule_ITKLevelSetsv4Visualization:BOOL=OFF \
	-DModule_ITKVideoBridgeOpenCV:BOOL=OFF \
	-DModule_ITKVideoBridgeVXL:BOOL=OFF \
	-DModule_ITKVtkGlue:BOOL=OFF \
	-DUSE_FFTWD:BOOL=ON \
	-DUSE_FFTWF:BOOL=ON \
	-DUSE_SYSTEM_FFTW:BOOL=ON \
	-DVCL_INCLUDE_CXX_0X:BOOL=ON \
	-DBUILD_EXAMPLES:BOOL=ON \
	-DBUILD_TESTING:BOOL=ON

VER_FULL = $(VER_MAJOR).$(VER_MINOR).$(VER_PATCH)
SOVERSION = $(VER_MAJOR).$(VER_MINOR)

UPSTREAM_SRC = InsightToolkit-$(VER_FULL)
DEBIAN_SRC_DIR = insighttoolkit-$(VER_FULL)
DEBIAN_SRC_TAR = insighttoolkit_$(VER_FULL).orig.tar.gz

pkg_lib = libinsighttoolkit$(SOVERSION)
pkg_dev = libinsighttoolkit$(VER_MAJOR)-dev
pkg_examples = insighttoolkit$(VER_MAJOR)-examples


%:
	dh $@ --builddir=BUILD --parallel

override_dh_auto_configure: pre-build
	dh_auto_configure -- $(CMAKE_FLAGS)

pre-build:
	echo "Available disk space:"
	df -h .

override_dh_auto_test:
	LD_LIBRARY_PATH=`pwd`/BUILD/lib dh_auto_test

override_dh_lintian:
	echo "$(pkg_lib): package-name-doesnt-match-sonames" > debian/$(pkg_lib).lintian-overrides
	echo "$(pkg_lib): embedded-library usr/lib/libitktiff-4.1.so.1: tiff" >> debian/$(pkg_lib).lintian-overrides
	dh_lintian

override_dh_install: 
	# pkg_lib
	dh_install -p$(pkg_lib) -XJava -XPython -XTcl debian/tmp/usr/lib/lib*.so.* usr/lib
	cp CMake/InsightValgrind.supp Insight$(SOVERSION)Valgrind.supp
	cp Modules/ThirdParty/VNL/src/vxl/config/valgrind.supp Insight$(SOVERSION)VxlValgrind.supp
	dh_install -p$(pkg_lib) Insight$(SOVERSION)*.supp usr/lib/valgrind
	#
	# pkg_dev
	dh_installman -p$(pkg_dev) debian/insighttoolkit.3
	dh_installdocs -p$(pkg_dev) Documentation/*
	dh_install -p$(pkg_dev) -XJava -XPython -XTcl debian/tmp/usr/lib/lib*.so usr/lib
	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/include/ITK-$(SOVERSION)/*
	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/lib/cmake
#	dh_install -p$(pkg_dev) Wrapping/WrapITK /usr/src

override_dh_installexamples:
	# pkg_examples
	dh_installexamples -p$(pkg_examples) Examples/*
ifneq (,$(filter $(pkg_examples), $(shell dh_listpackages)))
	find debian/$(pkg_examples)/usr/share/doc/$(pkg_examples)/examples \
	    -type f -print0 | xargs -0 chmod 644
endif

$(UPSTREAM_SRC).tar.gz:
	wget http://voxel.dl.sourceforge.net/sourceforge/itk/$@

get-orig-source: $(UPSTREAM_SRC).tar.gz
	tar xzf $(UPSTREAM_SRC).tar.gz
	find $(UPSTREAM_SRC) -name CVS -o -name Patented | xargs rm -rf
	mv $(UPSTREAM_SRC) $(DEBIAN_SRC_DIR)
	GZIP="--best --no-name" tar czf $(DEBIAN_SRC_TAR) $(DEBIAN_SRC_DIR)

control-file:
	sed -e "s/@VER_MAJOR@/$(VER_MAJOR)/g" \
	    -e "s/@SOVERSION@/$(SOVERSION)/g" \
	    < debian/control.in > debian/control.tmp
	[ -e debian/control ] \
	  && cmp -s debian/control debian/control.tmp \
	  && rm -f debian/control.tmp && exit 0; \
	  mv debian/control.tmp debian/control
